VERSION 5.00
Object = "{F9043C88-F6F2-101A-A3C9-08002B2F49FB}#1.2#0"; "COMDLG32.OCX"
Begin VB.Form MainForm 
   Caption         =   "DB Shuffle"
   ClientHeight    =   3915
   ClientLeft      =   855
   ClientTop       =   1305
   ClientWidth     =   6990
   LinkTopic       =   "Form1"
   PaletteMode     =   1  'UseZOrder
   ScaleHeight     =   3915
   ScaleWidth      =   6990
   Begin VB.CommandButton Exit 
      Caption         =   "E&xit"
      Height          =   495
      Left            =   4560
      TabIndex        =   4
      Top             =   3000
      Width           =   1695
   End
   Begin VB.CommandButton ImportToDatabase 
      Caption         =   "&Import Data Into ACT!"
      Height          =   495
      Left            =   2640
      TabIndex        =   3
      Top             =   3000
      Width           =   1695
   End
   Begin VB.CommandButton ExportToFile 
      Caption         =   "&Export DataTo File"
      Height          =   495
      Left            =   840
      TabIndex        =   2
      Top             =   3000
      Width           =   1575
   End
   Begin VB.Frame Frame1 
      Caption         =   " Current Status "
      Height          =   2055
      Left            =   120
      TabIndex        =   1
      Top             =   720
      Width           =   6735
      Begin VB.ListBox lstStatus 
         Height          =   1425
         ItemData        =   "DBShuffle.frx":0000
         Left            =   120
         List            =   "DBShuffle.frx":0002
         TabIndex        =   5
         Top             =   240
         Width           =   6492
      End
   End
   Begin MSComDlg.CommonDialog dlgFileDialog 
      Left            =   120
      Top             =   2808
      _ExtentX        =   847
      _ExtentY        =   847
      _Version        =   393216
   End
   Begin VB.Label Label1 
      Caption         =   $"DBShuffle.frx":0004
      Height          =   495
      Left            =   240
      TabIndex        =   0
      Top             =   120
      Width           =   6495
      WordWrap        =   -1  'True
   End
End
Attribute VB_Name = "MainForm"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False


Private Sub AddRecurringActivityInfo(ByRef Table, ByRef file)
    'Makes an Activity Recurring and adds the type, enddate ,etc.
    Dim nrecType As Integer
    Dim strIn As String
    Dim sActUid As String
    Dim nrecFreq As String
    Dim sUntilDate As String
    Dim nWeekBits As Integer
    Dim nDayBits As Integer
    
    ' Get the activity Id and Go to it
    Input #file, strIn
    sActUid = UnEscapeQoutes(strIn)
    Table.GoTo sActUid
    'Get the recurring type
    Input #file, strIn
    nrecType = Int(strIn)
    If nrecType = 0 Then
        Return
    End If
    'Get the recurring until date
     Input #file, strIn
    sUntilDate = strIn
    'Get the recurring frequency
    Input #file, strIn
    nrecFreq = Int(strIn)
     If nrecType = 1 Then   'Recurring Type is Daily
            Table.SetRecurringDays nrecFreq, DateValue(sUntilDate)
        ElseIf nrecType = 2 Then   'Recurring Type Weekly
            Input #file, strIn     'Get the ored value of the weeks
            Table.SetRecurringWeekDays nrecFreq, Int(strIn), DateValue(sUntilDate)
        ElseIf nrecType = 3 Then   'Recurring type Monthly
            Input #file, strIn      'Get the ored value of the days
            Table.SetRecurringDaysOfMonth nrecFreq, Int(strIn), DateValue(sUntilDate)
        ElseIf nrecType = 4 Then   'Recurring type Custom
            Input #file, strIn        'Get the ored value of the days
            nDayBits = Int(strIn)
            Input #file, strIn
            nWeekBits = Int(strIn)      'Get the ored value of the weeks
            Table.SetRecurringDaysAndWeeksofMonth nrecFreq, nDayBits, nWeekBits, DateValue(sUntilDate)
        End If
       
 
End Sub

Public Function Login(objDatabase As Object) As Boolean
    Dim LoginForm1 As LoginForm
    LoginForm.Show 1
    strUsername = LoginForm.UserName.Text
    strPassword = LoginForm.Password
    'Call the Validate User Method to Verify UserName Password
    objDatabase.ValidateUser strUsername, strPassword
    ' If Error then ValidateUser was unscuccesful
    If objDatabase.Error Then
        Login = False
    Else
        Login = True
    End If
End Function
Function ExportDatabaseToFile(ByVal strDatabase, ByVal strTextFile)
    'This routine opens the text file and the database and calls the various routines to write
    'all the information in all the tables.
    
    Dim objDatabase As Object
    Dim objContacts As Object
    Dim objGroup As Object
    Dim objEmail As Object
    Dim objNoteHistory As Object
    Dim objActivity As Object
    Dim objListTable As Object
    Dim objSales As Object
    
    UpdateStatus "Creating Database Object"
    'Create the Database Object
    Set objDatabase = CreateObject("ACTOLE.DATABASE")
    If Val(objDatabase.Version) < 5 Then
        MsgBox "This application needs at least ACT! 2000 to execute." & vbCrLf & "Please Upgrade, Now Exiting Application"
        Set objDatabase = Nothing
        End
    End If
    UpdateStatus "Opening ACT! Database file: " & strDatabase
    objDatabase.Open strDatabase
    ' perform login validation
    If objDatabase.IsMultiUser Then
        If Not Login(objDatabase) Then
            UpdateStatus "Failed user validation process!!!"
            Exit Function
        End If
    End If
    
    If objDatabase.IsOpen Then
    Screen.MousePointer = 11   'Let the icon become an hourglass
    UpdateStatus "Database opened successfully."
       
        ' assign the object
        Dim fieldcount As Integer
        Dim fieldlist(200) As Integer
        Dim strOut As String
        Dim fOutputFile As Integer
        
        ' Open/Create the text file...
        fOutputFile = 1
        Open strTextFile For Output As fOutputFile
        UpdateStatus "Writing Contacts!"
        'Create the Contact table object
        Set objContacts = objDatabase.CONTACT
        'Write the Contact Table Layout Information to the text file
        WriteTableLayoutToFile objContacts, fOutputFile, fieldlist, fieldcount, 204, "CL"
        'Write the Contact Table Information to the text file
        WriteTableDataToFile objContacts, fOutputFile, fieldlist, fieldcount, "CR"
        'Close and destory the ContactTable Object.
        objContacts.Close
        Set objContacts = Nothing
        
        'Create the Group Table Object
        Set objGroup = objDatabase.Group
        DoEvents           'Let other Windows events occur
        UpdateStatus "Writing Groups!"
        'Write the Group Table Layout Information to the text file
        WriteTableLayoutToFile objGroup, fOutputFile, fieldlist, fieldcount, 200, "GL"
          'Write the Group Table Information to the text file
        WriteTableDataToFile objGroup, fOutputFile, fieldlist, fieldcount, "GR"
        objGroup.Close
        Set objGroup = Nothing
        
        UpdateStatus "Writing Emails!"
        'Create the Email Table Object
        Set objEmail = objDatabase.EMAIL
        objDatabase.EMAIL.ClearContactScope
         'Write the Email Table Layout Information to the text file
        WriteTableLayoutToFile objDatabase.EMAIL, fOutputFile, fieldlist, fieldcount, 200, "EL"
        'Write the Email Table Information to the text file
        WriteTableDataToFile objDatabase.EMAIL, fOutputFile, fieldlist, fieldcount, "ER"
        objEmail.Close
        Set objEmail = Nothing
        
        UpdateStatus "Writing Activities!"
        'Create the Activity Table Object
        Set objActivity = objDatabase.ACTIVITY
        objDatabase.ACTIVITY.ClearContactScope
        'Writing Activity Table Layout and all activity records
        WriteTableLayoutToFile objDatabase.ACTIVITY, fOutputFile, fieldlist, fieldcount, 200, "AL"
        WriteTableDataToFile objDatabase.ACTIVITY, fOutputFile, fieldlist, fieldcount, "AR"
        objActivity.Close
        Set objActivity = Nothing
        
        'Create NoteHistory Object
        Set objNoteHistory = objDatabase.NOTEHISTORY
        UpdateStatus "Writing NoteHistory!"
        objDatabase.NOTEHISTORY.ClearContactScope
        'Writing NoteHistory Table Layout and all NoteHistory records
        WriteTableLayoutToFile objDatabase.NOTEHISTORY, fOutputFile, fieldlist, fieldcount, 200, "NL"
        WriteTableDataToFile objDatabase.NOTEHISTORY, fOutputFile, fieldlist, fieldcount, "NR"
        objNoteHistory.Close
        Set objNoteHistory = Nothing
        
        'Create ListTable Object
        Set objListTable = objDatabase.LISTTABLE
        UpdateStatus "Writing ListTable!"
        objDatabase.LISTTABLE.ClearScope
        
        'Writing ListTable Table Layout and all ListTable records
        WriteTableLayoutToFile objDatabase.LISTTABLE, fOutputFile, fieldlist, fieldcount, 200, "LL"
        WriteTableDataToFile objDatabase.LISTTABLE, fOutputFile, fieldlist, fieldcount, "LR"
        objListTable.Close
        Set objListTable = Nothing
        
         UpdateStatus "Writing Sales!"
        'Create the Sales Table Object
        Set objSales = objDatabase.SALES
        objDatabase.SALES.ClearContactScope
        'Writing Sales Table Layout and all sales records
        WriteTableLayoutToFile objDatabase.SALES, fOutputFile, fieldlist, fieldcount, 200, "SL"
        WriteTableDataToFile objDatabase.SALES, fOutputFile, fieldlist, fieldcount, "SR"
        objSales.Close
        Set objSales = Nothing
        
        'Close the text file
        Close fOutputFile
       
       'Close the Database
        UpdateStatus "Closing Database"
        objDatabase.Close
        UpdateStatus "Database Closed"
        'Reset the Mouse Pointer
        Screen.MousePointer = 0
    End If

    Set objDatabase = Nothing
    UpdateStatus "Destoryed Database Object"
    UpdateStatus "Done Exporting"
End Function


Private Sub GetLayOut(ByRef file, ByRef fields, ByRef count)
'This sub reads the text file and gets the tableLayout information
Dim strIn As String
Dim curpos As Integer

    count = 0
    Input #1, strIn
    count = Int(strIn)
    For curpos = 1 To count
       Input #1, strIn
       fields(curpos) = Int(strIn)
    Next
End Sub
Private Sub PutNewRecord(ByRef file, ByRef fields, ByRef count, ByRef Table, ByRef strUniqueId, ByRef strUserUniqueId)
' Add a new Record
Dim strIn As String
Dim curpos As Integer
    Table.Add      'Start Creating the record
    For curpos = 2 To count
       Input #file, strIn
         'Call the UnEscapeQuotes function to replace tabs with quotes.
       strIn = UnEscapeQoutes(strIn)
     
       If fields(curpos) = 6 Then
            strIn = strUserUniqueId
       End If
       
       If (Len(strIn) > 0) Then
            Table.Data fields(curpos), strIn   'Add the Data
            If (Table.LastError <> 0 And Table.Name <> "Contact" And fields(curpos) <> 201) Then
                MsgBox "Error updating table '" & Table.Name & " for unique id: " & strUniqueId & " for Field id : " & Str(fields(curpos)) & " and Data was :" & strIn
            End If
       End If
    Next
    Table.Data 1, strUniqueId
    Table.Update
End Sub
Private Sub UpdateOldRecord(ByRef file, ByRef fields, ByRef count, ByRef Table, ByRef strUserUniqueId)
Dim strIn As String
Dim curpos As Integer
'If the record exists then update the record with new values --
    Table.Edit
    For curpos = 2 To count
       Input #file, strIn
       
       strIn = UnEscapeQoutes(strIn)
       
       If fields(curpos) = 6 Then
            strIn = strUserUniqueId
       End If
       
       If Len(strIn) <> 0 Then
            ' Only update data if differnt otherwise pass...
            If Table.Data(fields(curpos)) <> strIn Then
                Table.Data fields(curpos), strIn
            End If
       End If
    Next
    Table.Update
End Sub
Private Sub AddRecordFromFileToTable(ByRef Table, ByRef file, ByRef fieldcount, ByRef fieldlist, ByRef strUserUniqueId)
    'Looks for a record ,if it exits goes into the dit mode or else adds a new record.
    Dim strIn As String
    ' Get the unique id first
    Input #file, strIn
  
    strIn = UnEscapeQoutes(strIn)
      ' Check existence by doing a lookup , if recordCount is < 1 then it does not exist
    Table.Lookup 1, strIn, 1
    If Table.RecordCount < 1 Then   'Add a new Record
        PutNewRecord file, fieldlist, fieldcount, Table, strIn, strUserUniqueId
    Else    'Modify the existing record
        Table.GoTo (strIn)
        UpdateOldRecord file, fieldlist, fieldcount, Table, strUserUniqueId
    End If
    Table.GoTo (strIn)
End Sub
Private Sub AddMembersToGroup(ByRef Table, ByRef file)
    'Populates a Group with its members.
    Dim nMembers As Long
    Dim strIn As String
 
    Input #file, strIn
    'Goto the particular group
    Table.GoTo (UnEscapeQoutes(strIn))
    Input #file, strIn
    ' Get the member count
    nMembers = Int(strIn)
    'Add the Contacts to a Group.
    If nMembers > 0 Then
        Table.Edit
         While (nMembers > 0)
            Input #file, strIn
            Table.AddContact (UnEscapeQoutes(strIn))  'Add the Contact to the group
            nMembers = nMembers - 1 ' decrement the member count...
         Wend
    Table.Update
    End If
End Sub
Private Sub AddAssociationToActivity(ByRef Table, ByRef file)
   'Links the activity to the Contact it has been scheduled with
    Dim nMembers As Integer
    Dim strIn As String
    Dim sActUid As String
    ' Get the association count first
    Input #file, strIn
    'Get the Activity UniqueId
    sActUid = UnEscapeQoutes(strIn)
    Table.GoTo sActUid     'Go the that particular activity
    Input #file, strIn
    nMembers = Int(strIn)  'Number of contacts the activity is associated with
    If nMembers = 0 Then
        Return
    End If
    ' Set the first scheduled with activity
    Input #file, strIn
    Table.FirstScheduledWith UnEscapeQoutes(strIn)
  
    'While number of contacts is > 0 keep doing NextScheduled with to get the
    'activity scheduled with multiple contacts other than the one First scheduled with
    nMembers = nMembers - 1
    While (nMembers > 0)
        Input #file, strIn
        Table.NextScheduledWith UnEscapeQoutes(strIn)
        nMembers = nMembers - 1 ' decrement the member count...
    Wend
  
End Sub

Private Sub AddExceptionsToActivity(ByRef Table, ByRef file)
'Adds the Exception Dates to a recurring Activity
    Dim nExceptions As Integer
    Dim strIn As String
    ' Get the activity unique Id  and go to it
    Input #file, strIn
    Table.GoTo strIn
    'Get the exception count
    Input #file, strIn
    nExceptions = Int(strIn)
    If nExceptions = 0 Then   'If no exceptions
        Return
    End If
    ' Set the Exception in a recurring activity
 
    While nExceptions > 0
        Input #file, strIn
        Table.EXCEPTIONINFO.Add (UnEscapeQoutes(strIn))
        nExceptions = nExceptions - 1 ' decrement the exception count...
    Wend
   
End Sub

Private Function EscapeQoutes(ByVal strToFix) As String
    'This routine takes a uniqueId and if there are quotes(") in it replaces it with a tab .
    'This has been done to avoid any problems associated with quotes in a text file.
    
    
    ' while there are quotes
    While InStr(strToFix, Chr(34))
        ' hold the position
        Position = InStr(strToFix, Chr(34))
        ' now replace the char with a Tab
        strToFix = Left(strToFix, Position - 1) & Chr(9) & Right(strToFix, Len(strToFix) - Position)
    Wend
    'return the data
    EscapeQoutes = strToFix
End Function
Private Function ImportFromFileToDatabase(ByVal strDatabase, ByVal strTextFile)
   'This function reads the text file and then Writes to database depending on What Type of record it is.
    
    Dim objDatabase As Object
    Dim lcounter As Long
    Dim strOut As String
    Dim fieldlist(200) As Integer
    Dim fieldcount As Integer
    Dim fInputFile As Integer
    Dim objContact As Object
    Dim objGroup As Object
    Dim objActivities As Object
    Dim objNoteHistory As Object
    Dim objListTable As Object
    Dim objSales As Object
     
    UpdateStatus "Creating Database Object"
    Set objDatabase = CreateObject("ACTOLE.DATABASE")
    If Val(objDatabase.Version) < 5 Then
        MsgBox "This application needs at least ACT!2000 to execute." & vbCrLf & "Please Upgrade, Now Exiting Application"
        Set objDatabase = Nothing
        End
    End If
    objDatabase.Open strDatabase
    ' perform login validation
    If objDatabase.IsMultiUser Then
        If Not Login(objDatabase) Then
            UpdateStatus "Failed user validation process!!!"
            Set objDatabase = Nothing
            Exit Function
        End If
    End If
    
    If objDatabase.IsOpen Then
        objDatabase.PhoneFormatting = 1
        ' assign the object
        Dim strIn As String
        Dim strUserId As String
        
        strUserId = objDatabase.USERS.CurrentUserId
        
        ' lets use file #1
        fInputFile = 1
        Open strTextFile For Input As fInputFile
      
        While (Not EOF(fInputFile))
             DoEvents
            Input #fInputFile, strIn
             Screen.MousePointer = 11
          
            ' Check if it is a layout field for a table...
            ' Is it contact record layout?
            If strIn = "CL" Then
                UpdateStatus "Importing Contact Record"
                GetLayOut fInputFile, fieldlist, fieldcount
            ' Is it group record layout?
            ElseIf strIn = "GL" Then
                UpdateStatus "Importing Group Record"
                GetLayOut fInputFile, fieldlist, fieldcount
            ' Is it email record layout?
            ElseIf strIn = "EL" Then
                UpdateStatus "Importing Email Record"
                GetLayOut fInputFile, fieldlist, fieldcount
            ' Is it activity record layout?
            ElseIf strIn = "AL" Then
                UpdateStatus "Importing Activity Record"
                GetLayOut fInputFile, fieldlist, fieldcount
            ' Is it contact record layout?
            ElseIf strIn = "NL" Then
                UpdateStatus "Importing NoteHistory Record"
                GetLayOut fInputFile, fieldlist, fieldcount
            ' Is it ListTable record layout?
            ElseIf strIn = "LL" Then
                UpdateStatus "Importing ListTable Record"
                GetLayOut fInputFile, fieldlist, fieldcount
            ' Is it Sales record layout?
            ElseIf strIn = "SL" Then
                UpdateStatus "Importing Sales Record"
                GetLayOut fInputFile, fieldlist, fieldcount
            ' Check if it is a record field
            ' Is it contact record
            ElseIf strIn = "CR" Then
                Set objContact = objDatabase.CONTACT
                AddRecordFromFileToTable objContact, fInputFile, fieldcount, fieldlist, strUserId
                Set objContact = Nothing
            ' Is it group record
            ElseIf strIn = "GR" Then
                Set objGroup = objDatabase.Group
                AddRecordFromFileToTable objGroup, fInputFile, fieldcount, fieldlist, strUserId
                Set objGroup = Nothing
            ' Is it Group membership list
            ElseIf strIn = "GM" Then
                Set objGroup = objDatabase.Group
                AddMembersToGroup objGroup, fInputFile
                Set objGroup = Nothing
            ' Is it email record
            ElseIf strIn = "ER" Then
                AddRecordFromFileToTable objDatabase.EMAIL, fInputFile, fieldcount, fieldlist, strUserId
            ' Is it activity record
            ElseIf strIn = "AR" Then
                AddRecordFromFileToTable objDatabase.ACTIVITY, fInputFile, fieldcount, fieldlist, strUserId
            ' Is it an activity exception list
            ElseIf strIn = "AE" Then
                AddExceptionsToActivity objDatabase.ACTIVITY, fInputFile
            ' Is it activity association list
            ElseIf strIn = "AA" Then
                AddAssociationToActivity objDatabase.ACTIVITY, fInputFile
            ' Is it Recurring activity information
            ElseIf strIn = "RA" Then
                AddRecurringActivityInfo objDatabase.ACTIVITY, fInputFile
            ' Is it notehistory record
            ElseIf strIn = "NR" Then
                AddRecordFromFileToTable objDatabase.NOTEHISTORY, fInputFile, fieldcount, fieldlist, strUserId
            'Is it ListTable record
            ElseIf strIn = "LR" Then
                AddRecordFromFileToTable objDatabase.LISTTABLE, fInputFile, fieldcount, fieldlist, strUserId
            'Is it Sales Record
            ElseIf strIn = "SR" Then
                AddRecordFromFileToTable objDatabase.SALES, fInputFile, fieldcount, fieldlist, strUserId
            End If
        Wend
        Screen.MousePointer = 0
        objDatabase.Close
        UpdateStatus "Database Closed"
    End If
    Close fInputFile
    Set objDatabase = Nothing
    UpdateStatus "Done Importing"
End Function
Private Function UnEscapeQoutes(ByVal strToFix) As String
    ' while there are qoutes
    While InStr(strToFix, Chr(9))
        ' hold the position
        Position = InStr(strToFix, Chr(9))
        ' now replace the char
        strToFix = Left(strToFix, Position - 1) & Chr(34) & Right(strToFix, Len(strToFix) - Position)
    Wend
    'return the data
    UnEscapeQoutes = strToFix
End Function
Private Sub WriteTableLayoutToFile(ByRef Table, ByRef file, ByRef fieldlist, ByRef fieldcount, ByRef MaxField, ByRef layouttype)
  'Write the Table Layout (fieldIds) to the text file
    Dim strOut As String
    Dim strLayout As String
    Dim lcounter As Long
    Dim FieldId As Integer
    ' Now dump all field data to the file...
    fieldcount = 0
    For lcounter = 0 To Table.fields.count - 1
        'List all properties for each field
        FieldId = Table.fields.FieldIdAt(lcounter)
        If (FieldId <> -1 And FieldId < MaxField) Then
            strOut = strOut & "," & Chr(34) & FieldId & Chr(34)
            fieldcount = fieldcount + 1
            fieldlist(fieldcount) = FieldId
        End If
    Next lcounter
        
    strLayout = Chr(34) & layouttype & Chr(34)
    strLayout = strLayout & "," & Chr(34) & fieldcount & Chr(34)
    strLayout = strLayout & strOut
        
    Print #file, strLayout
End Sub
Private Sub WriteTableDataToFile(ByRef Table, ByRef file, ByRef fieldlist, ByRef fieldcount, ByRef recordtype)
    Dim strOut As String
    ' Now write all data in the table to the Text File
    Table.MoveFirst
    For RecordCount = 1 To Table.RecordCount
        DoEvents
        strOut = Chr(34) & recordtype & Chr(34)
        For lcounter = 1 To fieldcount
            'List all properties for each field
            strOut = strOut & "," & Chr(34) & EscapeQoutes(Table.Data(fieldlist(lcounter))) & Chr(34)
        Next
        Print #file, strOut
        'If Table is group call the WriteGroupMembershipToFile for this GroupId
        If Table.Name = "Group" Then
            WriteGroupMembershipToFile Table, file
        'If Table is activityp call the functions associated for this activityId
        ElseIf Table.Name = "Activity" Then
            WriteActivityAssociationsToFile Table, file
            WriteRecurringActivityDetailsToFile Table, file
            WriteActivityExceptionsToFile Table, file
        End If
        Table.MoveNext
    Next RecordCount
   
End Sub
Private Sub WriteGroupMembershipToFile(ByRef Table, ByRef file)
'Write all the members of the current group to a text file
    Dim strOut As String
    Dim strOut1 As String
    Dim i As Integer
    Dim j As Integer
    Dim nLines As Integer
    Dim nrem As Integer
    ' Now write all data in the table...
    
    strOut1 = Chr(34) & "GM" & Chr(34) & "," & Chr(34) & EscapeQoutes(Table.Data(1)) & Chr(34)
    If Table.ContactCount < 80 Then
        strOut = strOut & "," & Chr(34) & Table.ContactCount & Chr(34)
        For i = 1 To Table.ContactCount
         'List all member's uniqueids
            strOut = strOut & "," & Chr(34) & EscapeQoutes(Table.MEMBERS.UniqueId) & Chr(34)
            Table.MEMBERS.MoveNext
        Next i
        strOut = strOut1 & strOut
        Print #file, strOut
   Else  'If there are more than 80 contacts for a particular group , write out in multiple lines ,to avoid having too many characters in a line
      nLines = Table.ContactCount / 80  'Number of lines
      nrem = Table.ContactCount Mod 80   'The remaining on a different line
      For j = 1 To nLines      'Lines of 80 contacts each
       strOut = "," & Chr(34) & "80" & Chr(34)
       For i = 1 To 80
            strOut = strOut & "," & Chr(34) & EscapeQoutes(Table.MEMBERS.UniqueId) & Chr(34)
            'List all member's uniqueids
            Table.MEMBERS.MoveNext
        Next i
        strOut = strOut1 & strOut
        Print #file, strOut
      Next j
      If nrem > 0 Then    'the remaining
         strOut = "," & Chr(34) & nrem & Chr(34)
         For i = 1 To nrem
            strOut = strOut & "," & Chr(34) & EscapeQoutes(Table.MEMBERS.UniqueId) & Chr(34)
            'List all member's uniqueids
            Table.MEMBERS.MoveNext
         Next i
         strOut = strOut1 & strOut
         Print #file, strOut
      End If
   End If
        
      
      
End Sub
Private Sub WriteActivityExceptionsToFile(ByRef Table, ByRef file)
'Writes all the Exceptions for a recurring activity.
    Dim strOut As String
    Dim strUniqueId
    Dim nExceptionCount
    Dim sActUid As String
    
    ' Now write all exception data in the table...
    If Table.IsRecurring Then
    
    
       ' Now write all data in the table...
       sActUid = Table.Data(1)    ' Get the Activity Unique Id
       
       nExceptionCount = Table.EXCEPTIONINFO.count    'Number of exceptions
       
       If nExceptionCount <> 0 Then
           For i = 1 To nExceptionCount
               strOut = strOut & "," & Chr(34) & Table.EXCEPTIONINFO.Value(i) & Chr(34)    'Exception Date
           Next
           strOut = Chr(34) & "AE" & Chr(34) & "," & Chr(34) & EscapeQoutes(sActUid) & Chr(34) & "," & Chr(34) & nExceptionCount & Chr(34) & strOut
           Print #file, strOut
       End If
    End If
End Sub
Private Sub WriteActivityAssociationsToFile(ByRef Table, ByRef file)
'Write Information about  all the Contacts an activity is scheduled with  is scheduled with
    Dim strOut As String
    Dim strUniqueId
    Dim nAssociationCount
    Dim sActUid As String
    
    ' Now write all data in the table...
    sActUid = Table.Data(1)    ' Get the Activity Unique Id
    strUniqueId = Table.FirstScheduledWith    'First Contact
    nAssociationCount = 0
    While (strUniqueId <> "")      'Get all the activities a contact is associated with
        strOut = strOut & "," & Chr(34) & EscapeQoutes(strUniqueId) & Chr(34)
        strUniqueId = Table.NextScheduledWith
        nAssociationCount = nAssociationCount + 1
    Wend
    strOut = Chr(34) & "AA" & Chr(34) & "," & Chr(34) & EscapeQoutes(sActUid) & Chr(34) & "," & Chr(34) & nAssociationCount & Chr(34) & strOut
    Print #file, strOut
End Sub
Private Sub WriteRecurringActivityDetailsToFile(ByRef Table, ByRef file)
'Write all Recurring Activity information to the text file
    Dim strOut As String
    Dim strUniqueId
    Dim nAssociationCount
    Dim sActUid As String
    Dim iRecurType As Integer
    
    ' Now write all data in the table...
    sActUid = Table.Data(1)    ' Get the Activity Unique Id
    If Table.IsRecurring Then
        strOut = strOut & "," & Chr(34) & Table.GetRecurringFrequency & Chr(34)  'Recurring frequency
        iRecurType = Table.recurringType
        Select Case iRecurType      'Find out what kind of recurring Activity
                    Case 2
                        strOut = strOut & "," & Chr(34) & Table.GetDaysOfWeekBits & Chr(34) 'Get the Days of Week
                    
                    Case 3
                        strOut = strOut & "," & Chr(34) & Table.GetDaysOfMonthBits & Chr(34) 'Get the Days of Month
                      
                    Case 4
                        strOut = strOut & "," & Chr(34) & Table.GetDaysOfWeekBits & Chr(34) & "," & Chr(34) & Table.GetWeeksOfMonthBits & Chr(34)
            
                End Select
        
    'Write out the Recurring type and the Recurring Until Date
    strOut = Chr(34) & "RA" & Chr(34) & "," & Chr(34) & EscapeQoutes(sActUid) & Chr(34) & "," & Chr(34) & Table.recurringType & Chr(34) & "," & Chr(34) & Table.GetRecurringUntilDate & Chr(34) & strOut
    Print #file, strOut

 End If

End Sub
Private Function GetDatabaseFileName(ByVal strTitle) As String
   'This sub gets the database fileName
    With dlgFileDialog
       If Right(.FileName, 4) <> ".dbf" Then
            .FileName = ""
        End If
        .Filter = "ACT! Database files (*.dbf)|*.dbf"
        .FilterIndex = 1
        .DialogTitle = strTitle
        .ShowOpen
        GetDatabaseFileName = .FileName
    End With
End Function


Private Function GetTextFileName(ByVal strTitle) As String
   'Get the Text file Name.
    With dlgFileDialog
        If Right(.FileName, 4) <> ".txt" Then
            .FileName = ""
        End If
        .Filter = "Text files (*.txt)|*.txt"
        .FilterIndex = 1
        .DialogTitle = strTitle
        .ShowOpen
        GetTextFileName = .FileName
    End With
End Function

Private Sub UpdateStatus(ByVal strStatus)
'User to wrte to the List box
    lstStatus.AddItem strStatus
End Sub


Private Sub Exit_Click()
 'Exit the Program
    End
End Sub

Private Sub ExportToFile_Click()
    Dim strDatabase As String
    Dim strTextFile As String
    
    strDatabase = GetDatabaseFileName("Select an ACT! Database to Export from")
    If Len(strDatabase) = 0 Then    'No database was selected
        'Add a Statement to be displayed
        UpdateStatus "No database was selected. Export Aborted"
        Exit Sub
    End If
    UpdateStatus "Database File: " & strDatabase & " selected for Export"
    strTextFile = GetTextFileName("Select a Text File to Export to")
    If Len(strTextFile) = 0 Then 'No textfile was selected
        UpdateStatus "No Text file was selected. Export Aborted"
        Exit Sub
    End If
    UpdateStatus "Text File: " & strTextFile & " selected for Export"
    'Calling the ExportDatabaseToFile Function
    ExportDatabaseToFile strDatabase, strTextFile
End Sub

Private Sub ImportToDatabase_Click()
'This sub gets the name of the file you would like to import from and  to.
    Dim strDatabase As String
    Dim strTextFile As String
    
    lstStatus.Clear
    strTextFile = GetTextFileName("Select a Text File to Import from")
    If Len(strTextFile) = 0 Then    'No Text file Selected
        UpdateStatus "No text file was selected. Import Aborted"
        Exit Sub
    End If
    UpdateStatus "Text File: " & strTextFile & " selected for Import"
    
    strDatabase = GetDatabaseFileName("Select an ACT! Database to Import Into")
    If Len(strDatabase) = 0 Then   'No Database selected
        UpdateStatus "No database was selected. Import Aborted"
        Exit Sub
    End If
    UpdateStatus "Database File: " & strDatabase & " selected for Import"
   ' Call the ImportFromFileToDatabase to start importing.
    ImportFromFileToDatabase strDatabase, strTextFile
End Sub

