VERSION 5.00
Object = "{7A769380-0D93-11D1-B268-444553540000}#1.0#0"; "ACTEVENT.OCX"
Begin VB.Form Form1 
   Caption         =   "ACT! Event Reporter"
   ClientHeight    =   4860
   ClientLeft      =   1140
   ClientTop       =   1965
   ClientWidth     =   6690
   DrawStyle       =   6  'Inside Solid
   LinkTopic       =   "Form1"
   PaletteMode     =   1  'UseZOrder
   ScaleHeight     =   4860
   ScaleWidth      =   6690
   Begin VB.CommandButton cmdStop 
      Caption         =   "Stop"
      Height          =   375
      Left            =   3480
      TabIndex        =   3
      Top             =   3840
      Width           =   1815
   End
   Begin VB.CommandButton cmdReport 
      Caption         =   "Start Reporting"
      Height          =   375
      Left            =   480
      TabIndex        =   2
      Top             =   3840
      Width           =   1815
   End
   Begin VB.Frame Frame1 
      Height          =   3495
      Left            =   120
      TabIndex        =   0
      Top             =   120
      Width           =   6255
      Begin VB.ListBox lstDisplay 
         Height          =   2790
         ItemData        =   "Main.frx":0000
         Left            =   120
         List            =   "Main.frx":0002
         TabIndex        =   1
         Top             =   360
         Width           =   6012
      End
   End
   Begin ACTEVENTLib.ActEvent ActEvent1 
      Left            =   120
      Top             =   3720
      _Version        =   65536
      _ExtentX        =   445
      _ExtentY        =   868
      _StockProps     =   0
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit
Dim objApp As Object
Dim objViews As Object
Dim objContactView As Object
Dim objGroupView As Object



Private Sub ActEvent1_OnActUserWantsToClose(ByVal bIsFinal As Boolean)
    If bIsFinal = False Then   'ACT is given an indication of user wanting to close, It is a good time to unitialize the application object
        MsgBox "ACT User Wants to close , Uninitializing Appliction Object " & vbCrLf & "Closing ACT!"
        Set objApp = Nothing
    Else
         ActEvent1.UnRegister
         End
    End If
End Sub

Private Sub ActEvent1_OnContactAdd(ByVal lpszUniqueID As String)
Dim RN As Long
'A New Contact has been added in ACT

Dim objV As Object
Dim objGrid As Object
Set objViews = objApp.Views
Set objV = objViews.GetActive

If lpszUniqueID <> "" Then   'After the New Contact has been saved
    lstDisplay.AddItem "Contact with uniqueId: " & lpszUniqueID & " Added"
    If objViews.GetLastError > 0 Then Exit Sub
    lstDisplay.AddItem "New Contact Info :"
    If objV.Type = 1 Then   'This the Contact View
                
        objV.GoTo lpszUniqueID
        lstDisplay.AddItem objV.GetField(CF_Name) & " , " & objV.GetField(CF_Company)
    
    ElseIf objV.Type = 2 Then  'This is the Contact List View
         Set objGrid = objV.GetGrid
         RN = objGrid.GetRowNumber(lpszUniqueID)
         lstDisplay.AddItem objGrid.GetField(CF_Name, RN) & " , " & objGrid.GetField(CF_Company, RN)
         Set objGrid = Nothing
    End If
    lstDisplay.AddItem ".........................................."
End If
Set objV = Nothing
    
End Sub

Private Sub ActEvent1_OnContactChange(ByVal lpszUniqueID As String)
'This Contact Information has been changed

Dim RN As Long
Dim objV As Object
Dim objGrid As Object
Set objViews = objApp.Views
Set objV = objViews.GetActive
lstDisplay.AddItem "Contact with uniqueId: " & lpszUniqueID & " Changed"
lstDisplay.AddItem "Contact Information: "
     If objViews.GetLastError > 0 Then Exit Sub
     If objV.Type = 1 Then   'This the Contact View
                
        objV.GoTo lpszUniqueID
        lstDisplay.AddItem objV.GetField(CF_Name) & " , " & objV.GetField(CF_Company)
    
    ElseIf objV.Type = 2 Then  'This is the Contact List View
         Set objGrid = objV.GetGrid
         RN = objGrid.GetRowNumber(lpszUniqueID)
         lstDisplay.AddItem objGrid.GetField(CF_Name, RN) & " , " & objGrid.GetField(CF_Company, RN)
         Set objGrid = Nothing
    End If
    lstDisplay.AddItem ".........................................."
Set objV = Nothing
End Sub


Private Sub ActEvent1_OnContactDelete(ByVal lpszUniqueID As String)
'Contact has been deleted
    lstDisplay.AddItem "Contact with uniqueId: " & lpszUniqueID & " Deleted"
    lstDisplay.AddItem ".........................................."
End Sub


Private Sub ActEvent1_OnContactListChange(ByVal nCount As Long)
'The Number of Contacts has been changed.
    lstDisplay.AddItem "Contact List Changed . New Contact Count :" & nCount
    lstDisplay.AddItem ".........................................."
End Sub

Private Sub ActEvent1_OnContactLookupChange()
'The Contact Lookup has changed
lstDisplay.AddItem "The Contact Lookup has Changed"
lstDisplay.AddItem ".............................."
End Sub


Private Sub ActEvent1_OnContactPosChange(ByVal lpszUniqueID As String)
'The Contact Position has changed
Dim RN As Long
Dim objV As Object
Set objViews = objApp.Views
Set objV = objViews.GetActive
lstDisplay.AddItem "The Current Contact now is " & lpszUniqueID
    
     If objV.Type = 1 Then   'This the Contact View
        lstDisplay.AddItem "Contact Information: "
        objV.GoTo lpszUniqueID
        lstDisplay.AddItem objV.GetField(CF_Name) & " , " & objV.GetField(CF_Company)
    
    End If
    lstDisplay.AddItem ".........................................."
Set objV = Nothing
End Sub



Private Sub ActEvent1_OnDatabaseClose()
'Database has Closed
lstDisplay.AddItem "Database has Closed"
lstDisplay.AddItem "..................."
End Sub


Private Sub ActEvent1_OnDatabaseOpen(ByVal lpszDBName As String)
   'Report the Database Open Event
    lstDisplay.AddItem "Database : " & lpszDBName & " Open"
    lstDisplay.AddItem ".........................................."
    
End Sub


Private Sub ActEvent1_OnGroupAdd(ByVal lpszUniqueID As String)
Set objGroupView = objViews.Create(3, "GV")
'A New Group has been added in ACT
    If lpszUniqueID <> "" Then
        lstDisplay.AddItem "Group with uniqueId: " & lpszUniqueID & " Added"
        lstDisplay.AddItem "GroupName: " & objGroupView.GetField(GF_Name)
        lstDisplay.AddItem ".........................................."
    End If
Set objGroupView = Nothing
End Sub

Private Sub ActEvent1_OnGroupChange(ByVal lpszUniqueID As String)
'The Group has been changed
    Set objGroupView = objViews.Create(3, "GV")
    lstDisplay.AddItem "Group with uniqueId: " & lpszUniqueID & " has been changed"
    lstDisplay.AddItem "GroupName: " & objGroupView.GetField(GF_Name)
    lstDisplay.AddItem ".........................................."
    
    Set objGroupView = Nothing
End Sub


Private Sub ActEvent1_OnGroupDelete(ByVal lpszUniqueID As String)
'Group deleted
    lstDisplay.AddItem "Group with uniqueId: " & lpszUniqueID & " Deleted"
    lstDisplay.AddItem ".........................................."
End Sub


Private Sub ActEvent1_OnGroupListChange(ByVal nCount As Long)
'The Number of Groups has been changed.
    lstDisplay.AddItem "Group List Changed . New Group Count :" & nCount
    lstDisplay.AddItem ".........................................."
End Sub


Private Sub ActEvent1_OnGroupPosChange(ByVal lpszUniqueID As String)
'The Group Position has changed
Set objViews = objApp.Views
Set objGroupView = objViews.Create(3, "GV")
lstDisplay.AddItem "The Current Group now is " & lpszUniqueID
lstDisplay.AddItem "GroupName: " & objGroupView.GetField(GF_Name)
lstDisplay.AddItem ".............................."

Set objGroupView = Nothing
End Sub

Private Sub cmdReport_Click()
Dim i As Long

'Register the ActEvent Control
i = ActEvent1.Register(0)
If i < 1 Then     'ActEvent did not get registered
    If ActEvent1.IsActRunning = False Then      'ACT is not up
        MsgBox "Act is not up!" & vbCrLf & "Bringing Up ACT! ."
        'Create the Application Object , This should bring up ACT
        Set objApp = CreateObject("ACTOLE.APPOBJECT")
        i = ActEvent1.Register(0)
        If i > 0 Then lstDisplay.AddItem "ACT is up. Reporting Begins"
        
    Else
        If i = -1 Then MsgBox "ActEvent is already registered!"   'Multiple registration not allowed
        If i <> -1 Then  'Some other problem
            lstDisplay.AddItem "Problem registering ACT Event. Please run actreg.exe and try again!"
            Exit Sub
        End If
    End If
Else
      'ACTEVENT was registered successfully .
      'Create the Application Object
      Set objApp = CreateObject("ACTOLE.APPOBJECT")
      
End If
    Set objViews = objApp.Views


   

    
End Sub


Private Sub cmdStop_Click()
'Unregister the ocx
   ' ActEvent1.UnRegister
    lstDisplay.Clear
    lstDisplay.AddItem "Event Reporting has stopped now"
    
'Release the AppObject and the Views object
    Set objViews = Nothing
    Set objApp = Nothing
    
    End
End Sub


