// Machine generated IDispatch wrapper class(es) created with ClassWizard
/////////////////////////////////////////////////////////////////////////////
// IActAppObj wrapper class

class IActAppObj : public COleDispatchDriver
{
public:
	IActAppObj() {}		// Calls COleDispatchDriver default constructor
	IActAppObj(LPDISPATCH pDispatch) : COleDispatchDriver(pDispatch) {}
	IActAppObj(const IActAppObj& dispatchSrc) : COleDispatchDriver(dispatchSrc) {}

// Attributes
public:
	CString GetCaption();
	void SetCaption(LPCTSTR);
	long GetLastContactListModTime();
	CString GetActVersion();

// Operations
public:
	BOOL IsVisible();
	BOOL IsDBOpen();
	CString GetAppName();
	CString GetAppPath();
	long GetSize(long* pWidth, long* pHeight);
	CString GetOpenDBName();
	long ReIndexDB(LPCTSTR DBName);
	long CompressDB(LPCTSTR DBName);
	long PurgeNotes(LPCTSTR DBName);
	long PurgeHistories(LPCTSTR DBName);
	long PurgeTransactions(LPCTSTR DBName);
	long AddUser(LPCTSTR UserName, short UserType);
	long ChangePassword(LPCTSTR UserName, LPCTSTR OldPassword, LPCTSTR NewPassword);
	LPDISPATCH OpenDB(LPCTSTR DBName);
	long OpenFile(LPCTSTR FileName);
	LPDISPATCH GetActiveDB();
	long Update();
	LPDISPATCH Views();
	LPDISPATCH Preferences();
	long Minimize();
	long Maximize();
	long Command(short CommandID);
	long ReSize(short Height, short Width);
	long Show(BOOL Display);
	long Help(LPCTSTR HelpFile, long ContextId);
	long CloseDB();
	long SaveCurrentLookup(LPCTSTR FileName);
	long RunMacro(LPCTSTR MacroName);
	long GetLastError();
	long ClearError();
	long SendKey(long param1, long param2, long param3);
	long GetPosition(long* pXPos, long* pYPos);
	CString GetUserId();
	long BackupDB(LPCTSTR szZip, short iItems, short iMode);
	long RestoreDB(LPCTSTR szSrc, LPCTSTR szDest, short iMode);
	CString GetVersion(short iFor);
	long ProcessFile(LPCTSTR szLinkFileName, long lReserved);
	BOOL Reserved(long lReserved1, long lReserved2, const VARIANT& vReserved);
	CString GetCurrentUserName();
	long GetUserPrivilege();
	long UpdateOutlookActivities(short iUpdateDirection, short iDurationType);
	long RemoveOutlookActivities(short iRemoveIn);
};
/////////////////////////////////////////////////////////////////////////////
// IAIBaseView wrapper class

class IAIBaseView : public COleDispatchDriver
{
public:
	IAIBaseView() {}		// Calls COleDispatchDriver default constructor
	IAIBaseView(LPDISPATCH pDispatch) : COleDispatchDriver(pDispatch) {}
	IAIBaseView(const IAIBaseView& dispatchSrc) : COleDispatchDriver(dispatchSrc) {}

// Attributes
public:
	BOOL GetActive();
	void SetActive(BOOL);
	BOOL GetDisplayed();
	void SetDisplayed(BOOL);
	CString GetCaption();
	void SetCaption(LPCTSTR);
	CString GetName();
	void SetName(LPCTSTR);
	long GetType();
	void SetType(long);
	short GetViewState();

// Operations
public:
	long Update();
	BOOL Activate();
	BOOL Maximize();
	BOOL Minimize();
	long ReSize(short iWidth, short iHeight);
	long Show(BOOL bDisplay);
	long Close();
	LPDISPATCH Application();
	LPDISPATCH Parent();
	long GetLastError();
	void ClearError();
};
/////////////////////////////////////////////////////////////////////////////
// IAIViews wrapper class

class IAIViews : public COleDispatchDriver
{
public:
	IAIViews() {}		// Calls COleDispatchDriver default constructor
	IAIViews(LPDISPATCH pDispatch) : COleDispatchDriver(pDispatch) {}
	IAIViews(const IAIViews& dispatchSrc) : COleDispatchDriver(dispatchSrc) {}

// Attributes
public:
	short GetCount();
	void SetCount(short);

// Operations
public:
	LPDISPATCH Create(short iType, LPCTSTR szName);
	LPDISPATCH GetView(short iType);
	long CloseAll();
	LPDISPATCH Application();
	LPDISPATCH GetActive();
	long GetLastError();
	long ClearError();
	LPDISPATCH FindExplorerView(LPCTSTR lpszViewName, short iType);
	LPDISPATCH CreateEx(short iType, LPCTSTR szName, short iState);
};
/////////////////////////////////////////////////////////////////////////////
// IAIContactView wrapper class

class IAIContactView : public COleDispatchDriver
{
public:
	IAIContactView() {}		// Calls COleDispatchDriver default constructor
	IAIContactView(LPDISPATCH pDispatch) : COleDispatchDriver(pDispatch) {}
	IAIContactView(const IAIContactView& dispatchSrc) : COleDispatchDriver(dispatchSrc) {}

// Attributes
public:
	BOOL GetActive();
	void SetActive(BOOL);
	BOOL GetDisplayed();
	void SetDisplayed(BOOL);
	CString GetCaption();
	void SetCaption(LPCTSTR);
	CString GetName();
	void SetName(LPCTSTR);
	long GetType();
	void SetType(long);
	short GetViewState();

// Operations
public:
	long Update();
	BOOL Activate();
	BOOL Maximize();
	BOOL Minimize();
	long ReSize(short iWidth, short iHeight);
	long Show(BOOL bDisplay);
	long Close();
	LPDISPATCH Application();
	LPDISPATCH Parent();
	long GetLastError();
	void ClearError();
	long MoveFirst();
	long MoveLast();
	long MoveNext();
	long Moveprevious();
	short GetCount();
	CString GetCurrentID();
	BOOL EOL();
	BOOL BOL();
	long AddNewContact();
	long Delete();
	long LookupAll();
	long LookupPrevious();
	long LookupMyRecord();
	long Goto(LPCTSTR szContactId);
	CString GetField(long lFieldId);
	long SetField(long lFieldId, LPCTSTR szFieldValue);
	long SaveQuery(LPCTSTR szFile);
	long RunQuery(LPCTSTR szFile);
	long LookupField(long iFieldId, LPCTSTR szFieldValue);
	CString GetActiveTab();
	long SetActiveTab(LPCTSTR szTabName);
	CString GetActiveGroup();
	long SetActiveGroup(LPCTSTR szGroupId);
	CString GetActiveGroupName();
	long SetActiveGroupName(LPCTSTR szGroupName);
	LPDISPATCH NotesHistory();
	LPDISPATCH Activities();
	LPDISPATCH GroupMembership();
	long AddContactToGroup(LPCTSTR szGroupId);
	long AddNoteHistory(short iType);
	long AddNewActivity(LPCTSTR szContactId);
	CString GetTabName(short iTabNumber);
	short GetTabCount();
	long NewContactDialog();
	CString SelectContactDlg(LPCTSTR lpszItem);
	CString AddNewActivityEx(LPCTSTR lpszItem, LPCTSTR szTime, short iType, short iTimeless, LPCTSTR szRegarding, long iDuration);
	CString AddNoteHistoryEx(short iType);
	CString AttachFile(LPCTSTR szFile);
	long LookupFieldEx(long iFieldId, LPCTSTR szFieldValue, short iType);
	long DeleteContactFast();
	short GetMode();
	long CurrentFieldId();
	BOOL HasRecordChanged();
	long CurrentRecord();
	long CreateLookup(LPCTSTR szContactIds);
	long LookupKeyword(LPCTSTR szKeyword, long iTables, short iLookupType, LPCTSTR szGroupId);
	LPDISPATCH Sales();
	CString CreateSalesForecast(LPCTSTR szContactId, LPCTSTR szProduct, LPCTSTR szType, LPCTSTR szMainCompetitor, long lUnits, float fUnitPrice, float fAmount, DATE closeDate, long lProbability);
	long CompleteSale(LPCTSTR szSaleId, short iStatus, DATE dateClosed, LPCTSTR szReason, long lUnits, float fUnitPrice, float fAmount);
	long ReopenSale(LPCTSTR szSaleId);
	long TriggerActivitySeries(short iLookupType, DATE startDate, LPCTSTR szActivitySeriesName);
};
/////////////////////////////////////////////////////////////////////////////
// IAIGroupView wrapper class

class IAIGroupView : public COleDispatchDriver
{
public:
	IAIGroupView() {}		// Calls COleDispatchDriver default constructor
	IAIGroupView(LPDISPATCH pDispatch) : COleDispatchDriver(pDispatch) {}
	IAIGroupView(const IAIGroupView& dispatchSrc) : COleDispatchDriver(dispatchSrc) {}

// Attributes
public:
	BOOL GetActive();
	void SetActive(BOOL);
	BOOL GetDisplayed();
	void SetDisplayed(BOOL);
	CString GetCaption();
	void SetCaption(LPCTSTR);
	CString GetName();
	void SetName(LPCTSTR);
	long GetType();
	void SetType(long);
	short GetViewState();

// Operations
public:
	long Update();
	BOOL Activate();
	BOOL Maximize();
	BOOL Minimize();
	long ReSize(short iWidth, short iHeight);
	long Show(BOOL bDisplay);
	long Close();
	LPDISPATCH Application();
	LPDISPATCH Parent();
	long GetLastError();
	void ClearError();
	long MoveFirst();
	long MoveLast();
	long MoveNext();
	long Moveprevious();
	short GetCount();
	CString GetCurrentID();
	BOOL EOL();
	BOOL BOL();
	long AddNew();
	long Delete();
	long LookupAll();
	long LookupPrevious();
	long Goto(LPCTSTR szGroupId);
	CString GetField(long lFieldId);
	long SetField(long lFieldId, LPCTSTR szFieldValue);
	long SaveQuery(LPCTSTR szFile);
	long RunQuery(LPCTSTR szFile);
	long LookupField(long iFieldId, LPCTSTR szFieldValue);
	CString GetActiveTab();
	long SetActiveTab(LPCTSTR szTab);
	LPDISPATCH NotesHistory();
	LPDISPATCH Activities();
	LPDISPATCH ContactMembers();
	long AddMemberToGroup(LPCTSTR szUniqueId);
	long AddNote();
	CString GetTabName(short iTabNumber);
	short GetTabCount();
	long AttachFile(LPCTSTR szFile);
	CString AddNoteEx();
	long LookupFieldEx(long iFieldId, LPCTSTR szFieldValue, short iType);
	long DeleteGroupFast();
	short GetMode();
	long CurrentFieldId();
	BOOL HasRecordChanged();
	long CurrentRecord();
	long LookupKeyword(LPCTSTR szKeyword, long iTables, short iLookupType, LPCTSTR szGroupId);
	long AddNewSubGroup(LPCTSTR szParentGroupId);
	long GetSubGroupCount();
	short GroupType();
	long ChangeToSubGroup(LPCTSTR szParentGroupId);
	long ChangeToParentGroup();
	long Expand();
	long Collapse();
	BOOL IsExpanded();
};
/////////////////////////////////////////////////////////////////////////////
// IAICalView wrapper class

class IAICalView : public COleDispatchDriver
{
public:
	IAICalView() {}		// Calls COleDispatchDriver default constructor
	IAICalView(LPDISPATCH pDispatch) : COleDispatchDriver(pDispatch) {}
	IAICalView(const IAICalView& dispatchSrc) : COleDispatchDriver(dispatchSrc) {}

// Attributes
public:
	BOOL GetActive();
	void SetActive(BOOL);
	BOOL GetDisplayed();
	void SetDisplayed(BOOL);
	CString GetCaption();
	void SetCaption(LPCTSTR);
	CString GetName();
	void SetName(LPCTSTR);
	long GetType();
	void SetType(long);
	short GetViewState();

// Operations
public:
	long Update();
	BOOL Activate();
	BOOL Maximize();
	BOOL Minimize();
	long ReSize(short iWidth, short iHeight);
	long Show(BOOL bDisplay);
	long Close();
	LPDISPATCH Application();
	LPDISPATCH Parent();
	long GetLastError();
	void ClearError();
	short GetActiveMonth();
	short GetCalendarMode();
	long SetCalendarMode(short iMode);
	long SetActiveMonth(short iMonth);
};
/////////////////////////////////////////////////////////////////////////////
// IAIEmail wrapper class

class IAIEmail : public COleDispatchDriver
{
public:
	IAIEmail() {}		// Calls COleDispatchDriver default constructor
	IAIEmail(LPDISPATCH pDispatch) : COleDispatchDriver(pDispatch) {}
	IAIEmail(const IAIEmail& dispatchSrc) : COleDispatchDriver(dispatchSrc) {}

// Attributes
public:
	BOOL GetActive();
	void SetActive(BOOL);
	BOOL GetDisplayed();
	void SetDisplayed(BOOL);
	CString GetCaption();
	void SetCaption(LPCTSTR);
	CString GetName();
	void SetName(LPCTSTR);
	long GetType();
	void SetType(long);
	short GetViewState();

// Operations
public:
	long Update();
	BOOL Activate();
	BOOL Maximize();
	BOOL Minimize();
	long ReSize(short iWidth, short iHeight);
	long Show(BOOL bDisplay);
	long Close();
	LPDISPATCH Application();
	LPDISPATCH Parent();
	long GetLastError();
	void ClearError();
	short GetInboxCount();
	CString GetInboxName(short iIndex);
	CString GetActiveInbox();
	long SetActiveInbox(LPCTSTR szName);
	long OpenInbox(LPCTSTR szName);
	LPDISPATCH MsgComposeView();
	short GetOpenFolderMessageCount();
	long Sort(long nColumnIndex, BOOL bSortType);
};
/////////////////////////////////////////////////////////////////////////////
// IAIMailCompose wrapper class

class IAIMailCompose : public COleDispatchDriver
{
public:
	IAIMailCompose() {}		// Calls COleDispatchDriver default constructor
	IAIMailCompose(LPDISPATCH pDispatch) : COleDispatchDriver(pDispatch) {}
	IAIMailCompose(const IAIMailCompose& dispatchSrc) : COleDispatchDriver(dispatchSrc) {}

// Attributes
public:
	BOOL GetActive();
	void SetActive(BOOL);
	BOOL GetDisplayed();
	void SetDisplayed(BOOL);
	CString GetCaption();
	void SetCaption(LPCTSTR);
	CString GetName();
	void SetName(LPCTSTR);
	long GetType();
	void SetType(long);
	short GetViewState();

// Operations
public:
	long Update();
	BOOL Activate();
	BOOL Maximize();
	BOOL Minimize();
	long ReSize(short iWidth, short iHeight);
	long Show(BOOL bDisplay);
	long Close();
	LPDISPATCH Application();
	LPDISPATCH Parent();
	long GetLastError();
	void ClearError();
	long ClearAll();
	long Send();
	long AddRecepient(LPCTSTR szInfo);
	long ClearRecepients();
	long SetSubject(LPCTSTR szSubject);
	long ClearSubject();
	long AddAttachment(LPCTSTR szAttachment);
	long ClearAttachments();
	long SetBodyText(LPCTSTR szBody);
	long ClearBodyText();
	long AddCCRecepient(LPCTSTR szInfo);
	long AddBCCRecepient(LPCTSTR szInfo);
};
/////////////////////////////////////////////////////////////////////////////
// IAIGrid wrapper class

class IAIGrid : public COleDispatchDriver
{
public:
	IAIGrid() {}		// Calls COleDispatchDriver default constructor
	IAIGrid(LPDISPATCH pDispatch) : COleDispatchDriver(pDispatch) {}
	IAIGrid(const IAIGrid& dispatchSrc) : COleDispatchDriver(dispatchSrc) {}

// Attributes
public:

// Operations
public:
	BOOL BOL();
	long DeleteRow(long nRowIndex);
	BOOL EOL();
	long GetColumnID(long nIndex);
	CString GetColumnName(long nIndex);
	long GetColumnCount();
	long GetCurrentRow();
	long GetRowCount();
	CString GetUniqueID(long nRowIndex);
	long Goto(long nIndex);
	long MoveFirst();
	long MoveLast();
	long MoveNext();
	long Moveprevious();
	long SelectRow(long nRowIndex, BOOL fAdd);
	long Sort(long nColumnIndex, BOOL bSortType);
	CString GetField(long lFieldId, long lRowNum);
	long SetField(long lFieldId, long lRowNum, LPCTSTR lpszData);
	long GetLastError();
	long GetRowNumber(LPCTSTR szUniqueId);
	long RefreshGrid();
	long SetFilter(long lFilters, const VARIANT& szDate, const VARIANT& szUserIdList);
	long GetFilter(long* lFilters, VARIANT* szDate, VARIANT* szUserIdList);
};
/////////////////////////////////////////////////////////////////////////////
// IAIContactListView wrapper class

class IAIContactListView : public COleDispatchDriver
{
public:
	IAIContactListView() {}		// Calls COleDispatchDriver default constructor
	IAIContactListView(LPDISPATCH pDispatch) : COleDispatchDriver(pDispatch) {}
	IAIContactListView(const IAIContactListView& dispatchSrc) : COleDispatchDriver(dispatchSrc) {}

// Attributes
public:
	BOOL GetActive();
	void SetActive(BOOL);
	BOOL GetDisplayed();
	void SetDisplayed(BOOL);
	CString GetCaption();
	void SetCaption(LPCTSTR);
	CString GetName();
	void SetName(LPCTSTR);
	long GetType();
	void SetType(long);
	short GetViewState();

// Operations
public:
	long Update();
	BOOL Activate();
	BOOL Maximize();
	BOOL Minimize();
	long ReSize(short iWidth, short iHeight);
	long Show(BOOL bDisplay);
	long Close();
	LPDISPATCH Application();
	LPDISPATCH Parent();
	long GetLastError();
	void ClearError();
	LPDISPATCH GetGrid();
	long AddNewContact();
	CString AddNewContactEx();
};
/////////////////////////////////////////////////////////////////////////////
// IAITaskListView wrapper class

class IAITaskListView : public COleDispatchDriver
{
public:
	IAITaskListView() {}		// Calls COleDispatchDriver default constructor
	IAITaskListView(LPDISPATCH pDispatch) : COleDispatchDriver(pDispatch) {}
	IAITaskListView(const IAITaskListView& dispatchSrc) : COleDispatchDriver(dispatchSrc) {}

// Attributes
public:
	BOOL GetActive();
	void SetActive(BOOL);
	BOOL GetDisplayed();
	void SetDisplayed(BOOL);
	CString GetCaption();
	void SetCaption(LPCTSTR);
	CString GetName();
	void SetName(LPCTSTR);
	long GetType();
	void SetType(long);
	short GetViewState();

// Operations
public:
	long Update();
	BOOL Activate();
	BOOL Maximize();
	BOOL Minimize();
	long ReSize(short iWidth, short iHeight);
	long Show(BOOL bDisplay);
	long Close();
	LPDISPATCH Application();
	LPDISPATCH Parent();
	long GetLastError();
	void ClearError();
	LPDISPATCH GetGrid();
	long AddNewActivity(LPCTSTR szId);
	CString AddNewActivityEx(LPCTSTR szId, LPCTSTR szTime, short iType, short iTimeless, LPCTSTR szRegarding, long iDuration);
};
/////////////////////////////////////////////////////////////////////////////
// IAIExplorerView wrapper class

class IAIExplorerView : public COleDispatchDriver
{
public:
	IAIExplorerView() {}		// Calls COleDispatchDriver default constructor
	IAIExplorerView(LPDISPATCH pDispatch) : COleDispatchDriver(pDispatch) {}
	IAIExplorerView(const IAIExplorerView& dispatchSrc) : COleDispatchDriver(dispatchSrc) {}

// Attributes
public:
	BOOL GetActive();
	void SetActive(BOOL);
	BOOL GetDisplayed();
	void SetDisplayed(BOOL);
	CString GetCaption();
	void SetCaption(LPCTSTR);
	CString GetName();
	void SetName(LPCTSTR);
	long GetType();
	void SetType(long);
	short GetViewState();

// Operations
public:
	long Update();
	BOOL Activate();
	BOOL Maximize();
	BOOL Minimize();
	long ReSize(short iWidth, short iHeight);
	long Show(BOOL bDisplay);
	long Close();
	LPDISPATCH Application();
	LPDISPATCH Parent();
	long GetLastError();
	void ClearError();
	CString GetURL();
	long SetURL(LPCTSTR lpszURL);
	CString GetStartupURL();
	long Stop();
	long Refresh();
	long GoForward();
	long GoBack();
};
/////////////////////////////////////////////////////////////////////////////
// IAIPreferences wrapper class

class IAIPreferences : public COleDispatchDriver
{
public:
	IAIPreferences() {}		// Calls COleDispatchDriver default constructor
	IAIPreferences(LPDISPATCH pDispatch) : COleDispatchDriver(pDispatch) {}
	IAIPreferences(const IAIPreferences& dispatchSrc) : COleDispatchDriver(dispatchSrc) {}

// Attributes
public:
	BOOL GetTabNavigation();
	void SetTabNavigation(BOOL);
	BOOL GetExitPrompt();
	void SetExitPrompt(BOOL);
	BOOL GetRememberPassword();
	void SetRememberPassword(BOOL);
	BOOL GetDisplayCountryCode();
	void SetDisplayCountryCode(BOOL);
	BOOL GetUseAct20Keys();
	void SetUseAct20Keys(BOOL);
	BOOL GetShowCurrentMonthOnly();
	void SetShowCurrentMonthOnly(BOOL);
	CString GetCalendarStartTime();
	void SetCalendarStartTime(LPCTSTR);
	CString GetCalendarWeekStartsOn();
	void SetCalendarWeekStartsOn(LPCTSTR);
	BOOL GetCheckScheduleConflicts();
	void SetCheckScheduleConflicts(BOOL);
	BOOL GetNewActivitiesPrivate();
	void SetNewActivitiesPrivate(BOOL);
	BOOL GetNewContactsPrivate();
	void SetNewContactsPrivate(BOOL);
	BOOL GetNewGroupsPrivate();
	void SetNewGroupsPrivate(BOOL);
	BOOL GetUseLastDBonStartup();
	void SetUseLastDBonStartup(BOOL);
	CString GetStartupDatabase();
	void SetStartupDatabase(LPCTSTR);
	CString GetStartupMacro();
	void SetStartupMacro(LPCTSTR);
	CString GetDefaultContactLayout();
	void SetDefaultContactLayout(LPCTSTR);
	CString GetDefaultGroupLayout();
	void SetDefaultGroupLayout(LPCTSTR);
	CString GetSecondGroupColumn();
	void SetSecondGroupColumn(LPCTSTR);
	BOOL GetNewActivitiesSeparate();
	void SetNewActivitiesSeparate(BOOL);
	long GetCalMinDurationForBanner();
	void SetCalMinDurationForBanner(long);
	BOOL GetEnableSpeedLoader();
	void SetEnableSpeedLoader(BOOL);
	long GetContactSalutation();
	void SetContactSalutation(long);
	BOOL GetGenerateSynchReport();
	void SetGenerateSynchReport(BOOL);
	CString GetReceivedSynchLocation();
	void SetReceivedSynchLocation(LPCTSTR);
	short GetAttachToMsgUsing();
	void SetAttachToMsgUsing(short);
	BOOL GetPromptToPrintEnvelope();
	void SetPromptToPrintEnvelope(BOOL);
	long GetRemindToBackUp();
	void SetRemindToBackUp(long);
	BOOL GetUseTypeahead();
	void SetUseTypeahead(BOOL);
	long GetWaitTime();
	void SetWaitTime(long);
	BOOL GetAttachMsgToContact();
	void SetAttachMsgToContact(BOOL);
	BOOL GetReturnReceipt();
	void SetReturnReceipt(BOOL);
	BOOL GetShowContactParsingDialog();
	void SetShowContactParsingDialog(BOOL);

// Operations
public:
	CString GetDefaultApplication(short iType);
	long SetDefaultApplication(short iType, LPCTSTR szAppname);
	CString GetDefaultLocation(short iType);
	long SetDefaultLocation(short iType, LPCTSTR szLoc);
	short GetCalendarIncrements(short iType);
	long SetCalendarIncrements(short iType, short iIncrement);
	short GetActivityCleanupStyle();
	long SetActivityCleanupStyle(short iStyle);
	CString GetSchdActivityDefaults(short iType);
	long SetSchdActivityDefaults(short iType, LPCTSTR szDefaults);
	short GetSchdAutoRollover();
	long SetSchdAutoRollover(short iRollover);
	long SetEmailInboxSettings(short iDelete, short iPollTime);
	long GetEmailInboxSettings(short* pDelete, short* pPollTime);
	CString GetEmailNewMsgInfo();
	long SetEmailNewMsgInfo(LPCTSTR szInfo);
	CString GetNameSettings(short iType);
	long SetNameSettings(short iType, LPCTSTR szNames);
	CString GetSynchSchedule();
	long SetSynchSchedule(LPCTSTR pInfo);
	CString GetSynchSettings();
	long SetSynchSettings(LPCTSTR szNewSettings);
	CString GetStyle(short iType);
	long SetStyle(short iType, LPCTSTR szNewStyle);
	CString GetEmailSystem();
	long SetEmailSystem(LPCTSTR szNewSystem);
	long GetLastError();
	long GetSynchUpdateInfo();
	long SetSynchUpdateInfo(long lNewInfo);
	long GetDataToSynch();
	long SetDataToSynch(long lNewInfo);
	CString GetAttachmentInfo();
	long SetAttachmentInfo(LPCTSTR szNewInfo);
	void ClearError();
	CString GetSynchScheduleInfo();
	long SetSynchScheduleInfo(LPCTSTR pInfo);
	long GetDBMaintReminderInfo(BOOL* pEnabled, long* pDayInterval);
	long SetDBMaintReminderInfo(BOOL bEnabled, long lDayInterval);
};
