VERSION 5.00
Begin VB.Form frmMain 
   BackColor       =   &H00C0C0C0&
   BorderStyle     =   3  'Fixed Dialog
   Caption         =   "Groups Sample"
   ClientHeight    =   4710
   ClientLeft      =   1005
   ClientTop       =   2235
   ClientWidth     =   6705
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   PaletteMode     =   1  'UseZOrder
   ScaleHeight     =   4710
   ScaleWidth      =   6705
   ShowInTaskbar   =   0   'False
   Begin VB.TextBox txtdbName 
      Height          =   375
      Left            =   240
      TabIndex        =   2
      Top             =   4080
      Width           =   6255
   End
   Begin VB.Frame Frame1 
      Height          =   3492
      Left            =   120
      TabIndex        =   0
      Top             =   120
      Width           =   6492
      Begin VB.ListBox lstDisplay 
         Height          =   3180
         ItemData        =   "GroupMain.frx":0000
         Left            =   120
         List            =   "GroupMain.frx":0002
         TabIndex        =   1
         Top             =   240
         Width           =   6255
      End
   End
   Begin VB.Frame Frame2 
      Caption         =   "ACT! Database to open"
      Height          =   855
      Left            =   120
      TabIndex        =   4
      Top             =   3720
      Width           =   6495
   End
   Begin VB.Label Label1 
      Caption         =   "Label1"
      Height          =   255
      Left            =   240
      TabIndex        =   3
      Top             =   3720
      Width           =   3495
   End
   Begin VB.Menu mnuFile 
      Caption         =   "File"
      Begin VB.Menu mnuFileExit 
         Caption         =   "Exit"
      End
   End
   Begin VB.Menu mnuAdd 
      Caption         =   "Add"
      Begin VB.Menu mnuAddGroup 
         Caption         =   "Add a Group"
      End
      Begin VB.Menu mnuAddSubgroup 
         Caption         =   "Add a SubGroup"
      End
      Begin VB.Menu mnuAddSep1 
         Caption         =   "------------------"
      End
      Begin VB.Menu mnuAddMember 
         Caption         =   "Add a member"
      End
      Begin VB.Menu mnuAddNote 
         Caption         =   "Add a note"
      End
   End
   Begin VB.Menu mnuList 
      Caption         =   "List"
      Begin VB.Menu mnuListGroups 
         Caption         =   "List All Groups"
      End
      Begin VB.Menu mnuListSubgroups 
         Caption         =   "List All SubGroups in a Group"
      End
      Begin VB.Menu mnuListMembers 
         Caption         =   "List All Members in a Groups"
      End
      Begin VB.Menu mnuListActivities 
         Caption         =   "List All Activities for a Group"
      End
      Begin VB.Menu mnuListSales 
         Caption         =   "List All sales for a Group"
      End
      Begin VB.Menu mnuListSep 
         Caption         =   "---------------------------------"
      End
      Begin VB.Menu muListFieldSchema 
         Caption         =   "List The Field Schema"
      End
   End
   Begin VB.Menu mnuMisc 
      Caption         =   "Misc"
      Begin VB.Menu mnuDeleteGroup 
         Caption         =   "Delete a Group or Subgroup"
      End
      Begin VB.Menu mnuMiscSep1 
         Caption         =   "--------------------------------"
      End
      Begin VB.Menu mnuLookup 
         Caption         =   "Lookup "
      End
      Begin VB.Menu mnuMiscSep2 
         Caption         =   "---------------------------"
      End
      Begin VB.Menu mnuChangeSubGrp 
         Caption         =   "Change a Subgroup to a Group"
      End
      Begin VB.Menu mnuChangeSubgroup 
         Caption         =   "Change a Group to a SubGroup"
      End
   End
End
Attribute VB_Name = "frmMain"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False











Private Sub cmdExit_Click()
  End
End Sub

















Private Sub cmdListActivities_Click()

End Sub

Private Sub cmdReload_Click()
     'This function reloads the database if
     'the database is changed by the user
     
    dbName = txtdbName.Text
    MsgBox "The database has changed"
    
    'The Contact Picker form needs to be reloaded
    'The Group Picker form needs to be reloaded
   Unload frmContactPicker
   Unload frmGroupPicker
   frmContactPicker.Hide
   frmGroupPicker.Hide
    
End Sub




Private Sub Form_Load()
    dbName = "C:\PROGRAM FILES\ACT\DATABASE\ACT5DEMO.DBF"
    txtdbName.Text = dbName
    bAlreadyLoggedIn = False
    Dim objDatabase As Object
    Set objDatabase = CreateObject("ACTOLE.DATABASE")
    'Check for version compatibality
    If Val(objDatabase.Version) < 5 Then
        MsgBox "This sample needs a ACT!2000 (version 5) or later."
        Set objDatabase = Nothing
        End
    End If
    Set objDatabase = Nothing
End Sub




Private Sub mnuAddGroup_Click()
  ' code to add a new group
    
    Dim objDatabase As Object
    Dim objGroup As Object
    Dim strGroupName As String
    Dim lcounter As Long
    Dim sGroupUniqueId As String
    
    ' display the add new contact dialog
    bOK = False
    strGroupName = InputBox("Enter the Group Name", "Add a Group", "GroupName")
    If strGroupName = " " Then
        Exit Sub
    End If
    
    lstDisplay.Clear
    lstDisplay.AddItem "Creating Database Object"
    Set objDatabase = CreateObject("ACTOLE.DATABASE")
    lstDisplay.AddItem "Is Open: " & objDatabase.IsOpen
    lstDisplay.AddItem "Opening Database"
    objDatabase.Open dbName
    
     ' perform login validation
    Dim bReturn As Boolean
    bReturn = Login(objDatabase)
    If Not bReturn Then
        lstDisplay.AddItem "Failed user validation process!!!"
    End If
    
    lstDisplay.AddItem "Database Open"
    lstDisplay.AddItem "Is Open: " & objDatabase.IsOpen
    Set objGroup = objDatabase.Group
    If objDatabase.IsOpen Then
        ' allocate a new record
        objGroup.Add
                    
        ' set field data
        objGroup.Data GF_Name, strGroupName
       
        ' update the records contents
        sGroupUniqueId = objGroup.Update
        
        'read the new group added
        objGroup.GoTo sGroupUniqueId
        lstDisplay.AddItem "New Group Added : " & objGroup.Data(GF_Name)
        
        lstDisplay.AddItem "Closing Database"
        Set objGroup = Nothing
        objDatabase.Close
        lstDisplay.AddItem "Database Closed"
    End If
    
    ' clear the object
    Set objDatabase = Nothing
    lstDisplay.SetFocus
End Sub

Private Sub mnuAddMember_Click()
'-----------------------------
    ' code to add a contact to a group
        
    Dim objDatabase As Object
    Dim objGroup As Object
    Dim lcounter As Long
    Dim strGroupID As String
    Dim strContactID As String
    Dim iPosition As Integer
      
     ' bring up the group chooser
    bOK = False
    frmGroupPicker.Show 1
    If bOK = False Then
        MsgBox " No Group was selected"
        Exit Sub ' return without doing anything
    End If
    
    'Parse the selected group item and get the group id
    iPosition = InStr(1, frmGroupPicker.lstPicker.Text, "|", 0)
    strGroupID = Left$(frmGroupPicker.lstPicker.Text, iPosition - 1)
    Unload frmGroupPicker
    
    ' bring up the contact chooser
    bOK = False
    frmContactPicker.Show 1
    If Not bOK Then
        MsgBox " No Contact was selected"
        Exit Sub ' return without doing anything
    End If
    
    iPosition = InStr(1, frmContactPicker.lstPicker.Text, "|", 0)
    strContactID = Left$(frmContactPicker.lstPicker.Text, iPosition - 1)
    lstDisplay.Clear
       
    lstDisplay.AddItem "Creating Database Object"
    Set objDatabase = CreateObject("ACTOLE.DATABASE")
    
    lstDisplay.AddItem "Is Open: " & objDatabase.IsOpen
    lstDisplay.AddItem "Opening Database"
    objDatabase.Open dbName
    
     ' perform login validation - nothing really happens
    Dim bReturn As Boolean
    bReturn = Login(objDatabase)
    If Not bReturn Then
        lstDisplay.AddItem "Failed user validation process!!!"
    End If
    
    lstDisplay.AddItem "Database Open"
    lstDisplay.AddItem "Is Open: " & objDatabase.IsOpen
    If objDatabase.IsOpen Then
        Set objGroup = objDatabase.Group
        'Go to the particular group
        objGroup.GoTo (strGroupID)
        objGroup.Edit
        'Add the contact to the group
        objGroup.AddContact (strContactID)
        objGroup.Update
        
        lstDisplay.AddItem "Contact added to Group"
          
        lstDisplay.AddItem "Closing Database"
        objDatabase.Close
        lstDisplay.AddItem "Database Closed"
    End If
    
    ' clear the object
    Set objDatabase = Nothing
    
    lstDisplay.SetFocus
End Sub

Private Sub mnuAddNote_Click()
'Code to add a note to a group

  Dim objDatabase As Object
  Dim objNoteHistory As Object
  Dim lcounter As Long
  Dim strGroupID As String
  Dim iPosition As Integer
      
    ' bring up the group chooser
    bOK = False
    frmGroupPicker.Show 1
    If Not bOK Then
        MsgBox "No Group Selected"
        Exit Sub ' return without doing anything
    End If
     
    iPosition = InStr(1, frmGroupPicker.lstPicker.Text, "|", 0)
    strGroupID = Left$(frmGroupPicker.lstPicker.Text, iPosition - 1)
    Unload frmGroupPicker
    ' display the add new note dialog
    bOK = False
    frmAddNote.Show 1
    If Not bOK Then     'The Note Text box is empty
        MsgBox "No Note to Add"
        Exit Sub       'Return without doing anything
    End If
    
    lstDisplay.Clear
       
    lstDisplay.AddItem "Creating Database Object"
    Set objDatabase = CreateObject("ACTOLE.DATABASE")
    
    lstDisplay.AddItem "Is Open: " & objDatabase.IsOpen
    lstDisplay.AddItem "Opening Database"
    objDatabase.Open dbName
    
     ' perform login validation
    Dim bReturn As Boolean
    bReturn = Login(objDatabase)
    If Not bReturn Then
        lstDisplay.AddItem "Failed user validation process!!!"
    End If
    
    lstDisplay.AddItem "Database Open"
    If objDatabase.IsOpen Then
                       
        lstDisplay.AddItem ""
        Set objNoteHistory = objDatabase.NoteHistory
        ' allocate a new record
        objNoteHistory.Add
                    
        ' set field data
        objNoteHistory.Data NHF_GroupId, strGroupID
        objNoteHistory.Data NHF_Text, frmAddNote.txtNote.Text
                                 
        ' update the records contents
        objNoteHistory.Update
        
        lstDisplay.AddItem ""
        lstDisplay.AddItem "Note has been added!!!"
        
        lstDisplay.AddItem "Closing Database"

        objDatabase.Close
        
        lstDisplay.AddItem "Database Closed"
    End If
    
    ' clear the object
    Set objDatabase = Nothing
    
    lstDisplay.SetFocus
End Sub

Private Sub mnuAddSubgroup_Click()
'-----------------------------
    ' code to add a new group
    
    Dim objDatabase As Object
    Dim Group1 As Object
    Dim objGroup As Object
    Dim lcounter As Long
    Dim guid As String
    
      bOK = False
    strGroupName = InputBox("Enter the Sub Group Name", "Add a SubGroup", "SubGroupName")
    If strGroupName = " " Then
        Exit Sub
    End If
     ' bring up the group chooser
    bOK = False
    bListGroup = True
    frmGroupPicker.Show 1
    If bOK = False Then
        MsgBox " No Group was selected"
        Exit Sub ' return without doing anything
    End If
    bListGroup = False
    'Parse the selected group item and get the group id
    iPosition = InStr(1, frmGroupPicker.lstPicker.Text, "|", 0)
    strGroupID = Left$(frmGroupPicker.lstPicker.Text, iPosition - 1)
    Unload frmGroupPicker
    lstDisplay.Clear
       
    lstDisplay.AddItem "Creating Database Object"
    Set objDatabase = CreateObject("ACTOLE.DATABASE")
    
    lstDisplay.AddItem "Is Open: " & objDatabase.IsOpen
    lstDisplay.AddItem "Opening Database"
    objDatabase.Open dbName
    If objDatabase.Error Then MsgBox objDatabase.LastError
    
     ' perform login validation
    Dim bReturn As Boolean
    bReturn = Login(objDatabase)
    If Not bReturn Then
        lstDisplay.AddItem "Failed user validation process!!!"
    End If
    
    lstDisplay.AddItem "Database Open"
    lstDisplay.AddItem "Is Open: " & objDatabase.IsOpen
    If objDatabase.IsOpen Then
        Set objGroup = objDatabase.Group
          lstDisplay.AddItem "Is Open: " & objGroup.RecordCount
          'Go to the Selected Group
          objGroup.GoTo strGroupID
          lstDisplay.AddItem "Creating a subgroup for Group : " & objGroup.Data(GF_Name)
        ' allocate a new SubGroup for the Selected Group
          objGroup.AddSubGroup
          If objGroup.Error Then MsgBox objGroup.LastError
     
    
            ' set field data
            objGroup.Data GF_Name, strGroupName
            objGroup.Data GF_Employees, "15"
            objGroup.Data GF_Industry, "Software"
            
       
        ' update the records contents
          guid = objGroup.Update
          If objGroup.Error Then MsgBox objGroup.LastError
        
        'Clear the Group object
        Set objGroup = Nothing
        lstDisplay.AddItem "Closing Database"
        objDatabase.Close
        lstDisplay.AddItem "Database Closed"
    End If
    
    ' clear the database object
      
    Set objDatabase = Nothing
    
    lstDisplay.SetFocus

End Sub

Private Sub mnuChangeSubgroup_Click()
'-----------------------------
' code to change a group to a subgroup.
       
    Dim objDatabase As Object
    Dim lcounter As Long
    Dim strGroupID, strParentGroupID As String
    Dim iPosition As Integer
    Dim objGroup As Object
    Dim objSGroup As Object
  
    
    ' bring up the Group chooser to select the subgroup to make a
    bOK = False
    bListGroup = True
    frmGroupPicker.Caption = " Select Group to be changed"
    frmGroupPicker.Show 1
    If Not bOK Then
        Exit Sub ' return without doing anything
    End If
     bListGroup = False
    
    'Parse the selected item from the chooser to get the Group unique id
    iPosition = InStr(1, frmGroupPicker.lstPicker.Text, "|", 0)
    strGroupID = Left$(frmGroupPicker.lstPicker.Text, iPosition - 1)
    Unload frmGroupPicker
    ' clear the listbox
    lstDisplay.Clear
    
    ' bring up the Group chooser to select the group to which to assign the subgroup to
    bOK = False
    bListGroup = True
    frmGroupPicker.Caption = " Select Group to this subgroup is to belong to"
    frmGroupPicker.Show 1
    If Not bOK Then
        Exit Sub ' return without doing anything
    End If
    
    'Parse the selected item from the chooser to get the Group unique id
    iPosition = InStr(1, frmGroupPicker.lstPicker.Text, "|", 0)
    strParentGroupID = Left$(frmGroupPicker.lstPicker.Text, iPosition - 1)
    Unload frmGroupPicker
    
    ' create the object
    lstDisplay.AddItem "Creating Database Object"
    Set objDatabase = CreateObject("ACTOLE.DATABASE")
    
    ' open the database
    lstDisplay.AddItem "Opening Database"
    objDatabase.Open dbName
    
     ' perform login validation
    Dim bReturn As Boolean
    bReturn = Login(objDatabase)
    If Not bReturn Then
        lstDisplay.AddItem "Failed user validation process!!!"
    End If
    
    lstDisplay.AddItem "Database Open"
    lstDisplay.AddItem "Is Open: " & objDatabase.IsOpen
    
    If objDatabase.IsOpen Then
          'Create Group Object
          Set objGroup = objDatabase.Group
          'Go to the selected group
          objGroup.GoTo strGroupID  ' go to selected group
          If objGroup.GetSubGroupCount = 0 Then   'if there are no subgroups
            
            objGroup.Edit
            objGroup.ChangeToSubGroup strParentGroupID       'change current group to be a subgroup of strParentGroup
            objGroup.Update
          
            If objGroup.Error Then MsgBox objGroup.LastError  'Flag error if there is one
           'Clear the Group object and close the database object
            lstDisplay.AddItem " "
         Else    'a group cannot be moved if there are subgroups
            lstDisplay.AddItem " The Group has subgroups . It cannot be moved!! "
            lstDisplay.AddItem " "
         End If
         Set objGroup = Nothing
         lstDisplay.AddItem "Closing Database"
         objDatabase.Close
        
         lstDisplay.AddItem "Database Closed"
    End If
    lstDisplay.SetFocus
    Set objDatabase = Nothing
End Sub

Private Sub mnuChangeSubGrp_Click()
    'Changes a subgroup to be a group
    Dim objDatabase As Object
    Dim lcounter As Long
    Dim strGroupID As String
    Dim iPosition As Integer
    Dim objGroup As Object
    Dim objSGroup As Object
  
    
    ' bring up the Group chooser
    bOK = False
    bListGroup = False
    bListSubGroup = True
    frmGroupPicker.Show 1
    If Not bOK Then
        Exit Sub ' return without doing anything
    End If
    bListSubGroup = False
    'Parse the selected item from the chooser to get the Group unique id
    iPosition = InStr(1, frmGroupPicker.lstPicker.Text, "|", 0)
    strGroupID = Left$(frmGroupPicker.lstPicker.Text, iPosition - 1)
    Unload frmGroupPicker
    ' clear the listbox
    lstDisplay.Clear
       
    ' create the object
    lstDisplay.AddItem "Creating Database Object"
    Set objDatabase = CreateObject("ACTOLE.DATABASE")
    
    ' open the database
    lstDisplay.AddItem "Opening Database"
    objDatabase.Open dbName
    
     ' perform login validation
    Dim bReturn As Boolean
    bReturn = Login(objDatabase)
    If Not bReturn Then
        lstDisplay.AddItem "Failed user validation process!!!"
    End If
    
    lstDisplay.AddItem "Database Open"
    lstDisplay.AddItem "Is Open: " & objDatabase.IsOpen
    
    If objDatabase.IsOpen Then
          'Create Group Object
          Set objGroup = objDatabase.Group
          'goto the selected group
          objGroup.GoTo strGroupID
          'Put the Group Record in edit mode
          objGroup.Edit
          objGroup.ChangeToParentGroup   ' Change the subgroup to be a Group
          objGroup.Update
          If objGroup.Error Then MsgBox objGroup.LastError
        
        'Clear the Group object and close the database object
         lstDisplay.AddItem " "
         Set objGroup = Nothing
         lstDisplay.AddItem "Closing Database"
         objDatabase.Close
        
         lstDisplay.AddItem "Database Closed"
    End If
    lstDisplay.SetFocus
    Set objDatabase = Nothing
          
End Sub

Private Sub mnuDeleteGroup_Click()
Dim objDatabase As Object
    Dim objGroup As Object
    Dim lcounter As Long
    Dim strGroupID As String
    Dim strContactID As String
    Dim iPosition As Integer
    Dim Response As Integer
    
     ' bring up the group chooser
    bOK = False
    frmGroupPicker.Show 1
    If bOK = False Then
        MsgBox " No Group was selected"
        Exit Sub ' return without doing anything
    End If
    
    'Parse the selected group item and get the group id
    iPosition = InStr(1, frmGroupPicker.lstPicker.Text, "|", 0)
    strGroupID = Left$(frmGroupPicker.lstPicker.Text, iPosition - 1)
    Unload frmGroupPicker
    
    lstDisplay.Clear
    lstDisplay.AddItem "Creating Database Object"
    Set objDatabase = CreateObject("ACTOLE.DATABASE")
    lstDisplay.AddItem "Is Open: " & objDatabase.IsOpen
    lstDisplay.AddItem "Opening Database"
    objDatabase.Open dbName
    
     ' perform login validation
    Dim bReturn As Boolean
    bReturn = Login(objDatabase)
    If Not bReturn Then
        lstDisplay.AddItem "Failed user validation process!!!"
    End If
    
    lstDisplay.AddItem "Database Open"
    lstDisplay.AddItem "Is Open: " & objDatabase.IsOpen
    
    If objDatabase.IsOpen Then
        Set objGroup = objDatabase.Group
        objGroup.GoTo strGroupID
        If objGroup.GroupType <> 0 Then
            'the current group is a subgroup
            Response = MsgBox("Are you sure you want to delete subgroup " & objGroup.Data(GF_Name), vbYesNo, "Delete Subgroup")
            If Response = vbYes Then
                objGroup.Delete   ' delete the subgroup
            End If
        Else  ' Now for Groups
            'check if the group has subgroups , if yes then popup a message box asking user to delete subgroups
            If objGroup.GetSubGroupCount > 0 Then
                MsgBox objGroup.Data(GF_Name) & " has subgroups. Delete them or move them and then try again !"
            Else  ' Group does not have subgroups , delete it.
                Response = MsgBox("Are you sure you want to delete group " & objGroup.Data(GF_Name), vbYesNo, "Delete Group")
                If Response = vbYes Then
                    objGroup.Delete   ' delete the group
                End If
            End If
        End If
        lstDisplay.AddItem " "
        
        Set objGroup = Nothing
        lstDisplay.AddItem "Closing Database"
        objDatabase.Close
        
        lstDisplay.AddItem "Database Closed"
    End If
    lstDisplay.SetFocus
    Set objDatabase = Nothing
    
End Sub

Private Sub mnuFileExit_Click()
    End
End Sub

Private Sub mnuListActivities_Click()
'This Function lists all the activities for a particular Group

Dim objDatabase As Object
Dim lcounter As Long
Dim strGroupID As String
Dim iPosition As Integer
Dim objActivity As Object
Dim uniqueID As String
  
    ' bring up the group chooser
    bOK = False
    frmGroupPicker.Show 1
    If Not bOK Then
        MsgBox "No Group has been Selected"
        Exit Sub ' return without doing anything
    End If

    'Parse the Selected item from the Group Picker to get the Group Id
    iPosition = InStr(1, frmGroupPicker.lstPicker.Text, "|", 0)
    strGroupID = Left$(frmGroupPicker.lstPicker.Text, iPosition - 1)
     Unload frmGroupPicker
    ' clear the listbox
    lstDisplay.Clear
       
    ' create the object
    lstDisplay.AddItem "Creating Database Object"
    Set objDatabase = CreateObject("ACTOLE.DATABASE")
    
    ' open the database
    lstDisplay.AddItem "Opening Database"
    objDatabase.Open dbName
    
     ' perform login validation -
    Dim bReturn As Boolean
    bReturn = Login(objDatabase)
    If Not bReturn Then
        lstDisplay.AddItem "Failed user validation process!!!"
    End If
    
    lstDisplay.AddItem "Database Open"
    lstDisplay.AddItem "Is Open: " & objDatabase.IsOpen
        
    ' assign the ACTIVITY object
    
    Set objActivity = objDatabase.Activity
    
    If objDatabase.IsOpen Then
        'Get the Activity Records for Group strGroupId
        objActivity.SetGroupScope strGroupID
        objActivity.MoveFirst
        While Not objActivity.IsEOF
                lstDisplay.AddItem "ACTIVITY Regarding   : " & objActivity.Data(AF_Regarding)
                lstDisplay.AddItem "ACTIVITY Start Time  : " & objActivity.Data(AF_StartTime)
                lstDisplay.AddItem "ACTIVITY End Time    : " & objActivity.Data(AF_EndTime)
                If Val(objDatabase.Version) >= 4 Then  ' details field exists in ACT!2000 (version 5) or later
                    lstDisplay.AddItem "ACTIVITY Details   : " & objActivity.Data(AF_Details)
                End If
                objActivity.MoveNext
        Wend
        Set objActivity = Nothing
        lstDisplay.AddItem " "
        lstDisplay.AddItem "Closing Database"
        objDatabase.Close
        lstDisplay.AddItem "Database Closed"
    End If
    
    Set objDatabase = Nothing
    lstDisplay.SetFocus
End Sub

Private Sub mnuListGroups_Click()
' code to list all the Groups
       
    Dim objDatabase As Object
    Dim objGroup As Object
    Dim lcounter As Long
    Dim iGroupCount As Integer
    
    ' clear the listbox
    lstDisplay.Clear
       
    ' create the object
    lstDisplay.AddItem "Creating Database Object"
    Set objDatabase = CreateObject("ACTOLE.DATABASE")
    
    ' open the database
    lstDisplay.AddItem "Opening Database"
    objDatabase.Open dbName
    
     ' perform login validation
    Dim bReturn As Boolean
    bReturn = Login(objDatabase)
    If Not bReturn Then
        lstDisplay.AddItem "Failed user validation process!!!"
    End If
    
    lstDisplay.AddItem "Database Open"
    lstDisplay.AddItem "Is Open: " & objDatabase.IsOpen
    lstDisplay.AddItem " "
    ' assign the Group object
    
    iGroupCount = 0
    Set objGroup = objDatabase.Group
    If objDatabase.IsOpen Then
         
        ' enumerate all groups
        If objGroup.RecordCount > 0 Then
            objGroup.MoveFirst
            
            While Not objGroup.IsEOF
                If objGroup.GroupType = 0 Then
                  lstDisplay.AddItem objGroup.Data(GF_Name)
                  iGroupCount = iGroupCount + 1
                End If
                  objGroup.MoveNext
            Wend
        End If
        lstDisplay.AddItem "---------------------------------------------------------------- "
         lstDisplay.AddItem "There are " & iGroupCount & " groups in this database."
        lstDisplay.AddItem " "
         Set objGroup = Nothing
        lstDisplay.AddItem "Closing Database"
        objDatabase.Close
        
        lstDisplay.AddItem "Database Closed"
    End If
    lstDisplay.SetFocus
    Set objDatabase = Nothing
  
End Sub

Private Sub mnuListMembers_Click()
'-----------------------------
' code to list all contacts for a group
       
    Dim objDatabase As Object
    Dim lcounter As Long
    Dim strGroupID As String
    Dim iPosition As Integer
    Dim objContact As Object
    Dim objMembers As Object
  
    ' bring up the Group chooser
    bOK = False
    frmGroupPicker.Show 1
    If Not bOK Then
        Exit Sub ' return without doing anything
    End If
    
    'Parse the selected item from the chooser to get the Group unique id
    iPosition = InStr(1, frmGroupPicker.lstPicker.Text, "|", 0)
    strGroupID = Left$(frmGroupPicker.lstPicker.Text, iPosition - 1)
     Unload frmGroupPicker
    ' clear the listbox
    lstDisplay.Clear
       
    ' create the object
    lstDisplay.AddItem "Creating Database Object"
    Set objDatabase = CreateObject("ACTOLE.DATABASE")
    
    ' open the database
    lstDisplay.AddItem "Opening Database"
    objDatabase.Open dbName
    
     ' perform login validation
    Dim bReturn As Boolean
    bReturn = Login(objDatabase)
    If Not bReturn Then
        lstDisplay.AddItem "Failed user validation process!!!"
    End If
    
    lstDisplay.AddItem "Database Open"
    lstDisplay.AddItem "Is Open: " & objDatabase.IsOpen
        
    ' assign the correct table object
    
    Set objContact = objDatabase.Contact
                    
    If objDatabase.IsOpen Then
               
        lstDisplay.AddItem "Record Count = " & objContact.RecordCount
        
        ' get the number of contacts in this group
        objDatabase.Group.GoTo (strGroupID)
        
        lstDisplay.AddItem "Group Name: " & frmGroupPicker.lstPicker.Text
        lstDisplay.AddItem "There are " & objDatabase.Group.ContactCount & " contacts in this group."
        lstDisplay.AddItem " "
                        
        ' enumerate all contacts in this group
        If objDatabase.Group.ContactCount > 0 Then
            Set objMembers = objDatabase.Group.Members
            If objDatabase.Group.ContactCount > 0 Then
                objMembers.MoveFirst
                While Not objMembers.IsEOF
                    lstDisplay.AddItem objMembers.Name
                    lstDisplay.AddItem "-----------------------------------"
                    objMembers.MoveNext
                Wend
            End If
        End If
        lstDisplay.AddItem " "
        
        Set objMembers = Nothing
        Set objContact = Nothing
        lstDisplay.AddItem "Closing Database"
        objDatabase.Close
        
        lstDisplay.AddItem "Database Closed"
    End If
    
    Set objDatabase = Nothing
    lstDisplay.SetFocus
End Sub

Private Sub mnuListSales_Click()
Dim objDatabase As Object
 Dim lcounter As Long
    
    '-----------------------------
    ' code to list all sales for a group

    ' bring up the table chooser
    bOK = False
    frmGroupPicker.Show 1
   If Not bOK Then
        Exit Sub ' return without doing anything
    End If
        
    Dim groupUniqueID As String
    Dim position As Integer
    position = InStr(1, frmGroupPicker.lstPicker.Text, "|", 0)
    groupUniqueID = Left$(frmGroupPicker.lstPicker.Text, position - 1)
    Unload frmGroupPicker
    ' clear the listbox
    lstDisplay.Clear
       
    ' create the object
    lstDisplay.AddItem "Creating Database Object"
    Set objDatabase = CreateObject("ACTOLE.DATABASE")
    
    ' open the database
    lstDisplay.AddItem "Opening Database"
    objDatabase.Open dbName
    
     ' perform login validation - nothing really happens
    Dim bReturn As Boolean
    bReturn = Login(objDatabase)
    If Not bReturn Then
        lstDisplay.AddItem "Failed user validation process!!!"
    End If
    
    lstDisplay.AddItem "Database Open"
    lstDisplay.AddItem "Is Open: " & objDatabase.IsOpen
        
    ' assign the correct table object
    Dim objSales As Object
    Set objSales = objDatabase.Sales
    
    If objDatabase.IsOpen Then
       
        lstDisplay.AddItem " "
        
        ' Make a list of sales records associated with the selected group
        objSales.SetGroupScope groupUniqueID
        objSales.MoveFirst
        lstDisplay.AddItem "Group has " & objSales.RecordCount & " Sales Records"
        lstDisplay.AddItem " "
        While Not objSales.IsEOF
                    
                lstDisplay.AddItem "Product :        " & objSales.Data(SLVF_ProductName)
                lstDisplay.AddItem "Type :            " & objSales.Data(SLF_TypeId)
                lstDisplay.AddItem "Sale Amount: " & objSales.Data(SLF_Amount)
                lstDisplay.AddItem "Date:              " & objSales.Data(SLF_SaleDate)
               
                lstDisplay.AddItem "----------------------------------------------------"
                
            objSales.MoveNext
        Wend
                         
        lstDisplay.AddItem " "
        lstDisplay.AddItem "Closing Database"
        objDatabase.Close
        lstDisplay.AddItem "Database Closed"
    End If
    
    Set objDatabase = Nothing
    
    lstDisplay.SetFocus
End Sub

Private Sub mnuListSubgroups_Click()
'-----------------------------
' code to list all contacts for a group
       
    Dim objDatabase As Object
    Dim lcounter As Long
    Dim strGroupID As String
    Dim iPosition As Integer
    Dim objGroup As Object
    Dim objSGroup As Object
  
    
    ' bring up the Group chooser
    bOK = False
    bListGroup = True
    frmGroupPicker.Show 1
    If Not bOK Then
        Exit Sub ' return without doing anything
    End If
    bListGroup = False
    'Parse the selected item from the chooser to get the Group unique id
    iPosition = InStr(1, frmGroupPicker.lstPicker.Text, "|", 0)
    strGroupID = Left$(frmGroupPicker.lstPicker.Text, iPosition - 1)
    Unload frmGroupPicker
    ' clear the listbox
    lstDisplay.Clear
       
    ' create the object
    lstDisplay.AddItem "Creating Database Object"
    Set objDatabase = CreateObject("ACTOLE.DATABASE")
    
    ' open the database
    lstDisplay.AddItem "Opening Database"
    objDatabase.Open dbName
    
     ' perform login validation
    Dim bReturn As Boolean
    bReturn = Login(objDatabase)
    If Not bReturn Then
        lstDisplay.AddItem "Failed user validation process!!!"
    End If
    
    lstDisplay.AddItem "Database Open"
    lstDisplay.AddItem "Is Open: " & objDatabase.IsOpen
    
    If objDatabase.IsOpen Then
          'Create Group Object
          Set objGroup = objDatabase.Group
          'Go to the selected group
          objGroup.GoTo strGroupID
          lstDisplay.AddItem objGroup.Data(GF_Name) & " has " & objGroup.GetSubGroupCount & " subgroups."
          'if the group has subgroups
          If objGroup.GetSubGroupCount > 0 Then
                'Create the Subgroup List object for the selected group
                Set objSGroup = objGroup.GetSubGroupList
                objSGroup.MoveFirst
                'Enumerate all the subgroups for the particular group
                For j = 1 To objSGroup.RecordCount
                    lstDisplay.AddItem "-----" & objSGroup.Data(GF_Name)
                    objSGroup.MoveNext
                Next j
                'Clear the subgroup List object
                Set objSGroup = Nothing
                
        End If
        lstDisplay.AddItem " "
        Set objGroup = Nothing
        lstDisplay.AddItem "Closing Database"
        objDatabase.Close
        
        lstDisplay.AddItem "Database Closed"
    End If
    lstDisplay.SetFocus
    Set objDatabase = Nothing
   
    
End Sub

Private Sub mnuLookup_Click()
'Perform Lookup on the Group Table

  Dim objDatabase As Object
  Dim objContact As Object
  Dim lcounter As Long
  Dim strLookup As String
  Dim isearchField As Integer
  Dim objGroup As Object
  
  isearchField = GF_Name 'default
  
    ' bring up the lookup form
    bOK = False
    frmLookup.Show 1
    If Not bOK Then
        strLookup = ""
    End If
    
    strLookup = frmLookup.txtLookupString
    
    If frmLookup.cboLookupField = "GROUP NAME" Then
        isearchField = GF_Name
    End If
    
    If frmLookup.cboLookupField = "DIVISION" Then
        isearchField = GF_Division
    End If
    
        
    ' clear the listbox
    lstDisplay.Clear
       
    ' create the object
    lstDisplay.AddItem "Creating Database Object"
    Set objDatabase = CreateObject("ACTOLE.DATABASE")
    
    ' open the database
    lstDisplay.AddItem "Opening Database"
    objDatabase.Open dbName
    
     ' perform login validation
    Dim bReturn As Boolean
    bReturn = Login(objDatabase)
    If Not bReturn Then
        lstDisplay.AddItem "Failed user validation process!!!"
    End If
    
    lstDisplay.AddItem "Database Open"
    lstDisplay.AddItem "Is Open: " & objDatabase.IsOpen
        
    ' assign the correct table object
    
    Set objGroup = objDatabase.Group
    
    If objDatabase.IsOpen Then
                   
        objGroup.Lookup isearchField, strLookup, 1
        
        'List number of records meeting the lookup criteria
        lstDisplay.AddItem objGroup.RecordCount & " Records Found!"
        lstDisplay.AddItem " "
        
        ' enumerate all of the records in the group
        objGroup.MoveFirst
        While Not objGroup.IsEOF
            lstDisplay.AddItem "GROUP: " & objGroup.Data(GF_Name)
            lstDisplay.AddItem "DIVISION:   " & objGroup.Data(GF_Division)
            lstDisplay.AddItem "ADDRESS: " & objGroup.Data(GF_Address1)
            lstDisplay.AddItem "         " & objGroup.Data(GF_City) & ", " & objGroup.Data(GF_State) & objGroup.Data(GF_Zip)
            lstDisplay.AddItem "----------------------------"
                
            objGroup.MoveNext
        Wend
                         
        lstDisplay.AddItem " "
        lstDisplay.AddItem "Closing Database"
        'Close Group and Database objects
        Set objGroup = Nothing
        objDatabase.Close
        lstDisplay.AddItem "Database Closed"
    End If
    
    Set objDatabase = Nothing
    
    lstDisplay.SetFocus
End Sub

Private Sub muListFieldSchema_Click()
'This function lists the field schema for all the fields
'in the Group Object.

 Dim objDatabase As Object
 Dim objGroup As Object
 Dim lcounter As Long
 Dim strOut As String
 Dim iFieldId As Integer
 
    lstDisplay.Clear
    lstDisplay.AddItem "*** Creating Database Object"
    Set objDatabase = CreateObject("ACTOLE.DATABASE")
    lstDisplay.AddItem "Is Open: " & objDatabase.IsOpen
                
    lstDisplay.AddItem "*** Opening Database"
    objDatabase.Open dbName
    lstDisplay.AddItem "*** Database Open"
    lstDisplay.AddItem "Is Open: " & objDatabase.IsOpen
                
    ' perform login validation
    Dim bReturn As Boolean
    bReturn = Login(objDatabase)
    If Not bReturn Then
        lstDisplay.AddItem "Failed user validation process!!!"
    End If
    'Check the Version of actole.dll. If majorversion returns 1 it is older than 3.06 and needs to be updated
    If objDatabase.MajorVersion = 1 Then
       MsgBox "You have an ACTOLE.dll older than version 3.06." & Chr(13) & "This function needs the new features. Please Update and Retry!  "
       lstDisplay.Clear
       objDatabase.Close
       Exit Sub
    End If
                
    If objDatabase.IsOpen Then
                
    ' assign the Group object
        Set objGroup = objDatabase.Group
        
        lstDisplay.AddItem "Name: " & objDatabase.Name
        lstDisplay.AddItem " "
        lstDisplay.AddItem "Record count: " & objGroup.RecordCount
        lstDisplay.AddItem "Field Count : " & objGroup.FieldCount
        lstDisplay.AddItem "Table Name : " & objGroup.Name
        lstDisplay.AddItem ""
    
        For lcounter = 0 To objGroup.Fields.Count()
            'List all properties for each field
            strOut = ""
            If (objGroup.Fields.FieldIdAt(lcounter) <> -1) Then
                iFieldId = objGroup.Fields.FieldIdAt(lcounter)
                strOut = strOut + "* Field " & ": " & " FIELD ID=" & objGroup.Fields.FieldIdAt(lcounter)
                strOut = strOut + " " & "Label=" & objGroup.Fields.Label(iFieldId)
                strOut = strOut + ", Type: " & objGroup.Fields.Type(iFieldId)
                strOut = strOut + ", Length: " & objGroup.Fields.Length(iFieldId)
                         
                lstDisplay.AddItem strOut
                strOut = ""
                strOut = strOut + "  Indexed:" & objGroup.Fields.IsIndexed(iFieldId)
                strOut = strOut + ", Initial Value:" & objGroup.Fields.InitialValue(iFieldId)
                strOut = strOut + ", Sortable:" & objGroup.Fields.IsSortable(iFieldId)
                strOut = strOut + ", Modifiable:" & objGroup.Fields.Modifiable(iFieldId)
                strOut = strOut + ", PopupList:" & objGroup.Fields.HasPopupList(iFieldId)
                lstDisplay.AddItem strOut
                         
                strOut = ""
                strOut = strOut + "   EntryTrigger=" & objGroup.Fields.EntryTrigger(iFieldId)
                strOut = strOut + ", ExitTrigger=" & objGroup.Fields.ExitTrigger(iFieldId)
                strOut = strOut + ", Automatically add items to drop down = " & objGroup.Fields.AutoPopulate(iFieldId)
                lstDisplay.AddItem strOut
                lstDisplay.AddItem ""
                         
            End If
        Next
        Set objGroup = Nothing
        lstDisplay.AddItem "*** Closing Database"
        objDatabase.Close
        lstDisplay.AddItem "*** Database Closed"
    End If
    Set objDatabase = Nothing
    lstDisplay.SetFocus
End Sub

Private Sub txtdbName_Change()
dbName = txtdbName.Text
End Sub


